#include "randomizer_check_objects.h"
#include <map>
#include <string>
#include <Cvar.h>
#include "z64.h"

/*
typedef struct {
    RandomizerCheck rc;
    RandomizerCheckVanillaOrMQ vOrMQ;
    RandomizerCheckType rcType;
    RandomizerCheckArea rcArea;
    ActorID actorId;
    SceneID sceneId;
    s32 actorParams;
    GetItemId ogItemId;
    bool visibleInImgui;
    std::string rcShortName;
    std::string rcSpoilerName;
} RandomizerCheckObject;
*/

//            RandomizerCheck,                                                RCVORMQ,         RCTYPE,              RCAREA,                        ActorId,            SceneId,                              ActorParams,                 OG ItemID,           "Short name", "Spoiler name"
std::map<RandomizerCheck, RandomizerCheckObject> rcObjects = {
    RC_OBJECT(RC_KF_KOKIRI_SWORD_CHEST,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_SPOT04,                         1248,                        GI_SWORD_KOKIRI,     "Kokiri Sword Chest", "KF Kokiri Sword Chest"),
    RC_OBJECT(RC_KF_MIDOS_TOP_LEFT_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_KOKIRI_HOME4,                   22944,                       GI_RUPEE_BLUE,       "Mido Top Left Chest", "KF Mido Top Left Chest"),
    RC_OBJECT(RC_KF_MIDOS_TOP_RIGHT_CHEST,                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_KOKIRI_HOME4,                   22945,                       GI_RUPEE_BLUE,       "Mido Top Right Chest", "KF Mido Top Right Chest"),
    RC_OBJECT(RC_KF_MIDOS_BOTTOM_LEFT_CHEST,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_KOKIRI_HOME4,                   22914,                       GI_RUPEE_GREEN,      "Mido Bottom Left Chest", "KF Mido Bottom Left Chest"),
    RC_OBJECT(RC_KF_MIDOS_BOTTOM_RIGHT_CHEST,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_KOKIRI_HOME4,                   22787,                       GI_HEART,            "Mido Bottom Right Chest", "KF Mido Bottom Right Chest"),
    RC_OBJECT(RC_KF_STORMS_GROTTO_CHEST,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KOKIRI_FOREST,          ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22988,                       GI_RUPEE_RED,        "Storms Grotto Chest", "KF Storms Grotto Chest"),
    RC_OBJECT(RC_KF_GS_BEAN_PATCH,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KOKIRI_FOREST,          ACTOR_EN_SI,        SCENE_SPOT04,                         27649,                       GI_SKULL_TOKEN,      "GS Bean Patch", "KF GS Bean Patch"),
    RC_OBJECT(RC_KF_GS_KNOW_IT_ALL_HOUSE,                                     RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KOKIRI_FOREST,          ACTOR_EN_SI,        SCENE_SPOT04,                         19458,                       GI_SKULL_TOKEN,      "GS Know It All House", "KF GS Know It All House"),
    RC_OBJECT(RC_KF_GS_HOUSE_OF_TWINS,                                        RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KOKIRI_FOREST,          ACTOR_EN_SI,        SCENE_SPOT04,                         19460,                       GI_SKULL_TOKEN,      "GS House of Twins", "KF GS House of Twins"),
    RC_OBJECT(RC_KF_LINKS_HOUSE_COW,                                          RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_KOKIRI_FOREST,          ACTOR_EN_COW,       SCENE_LINK_HOME,                      0x00,                        GI_MILK,             "Links House Cow", "KF Links House Cow"),
    RC_OBJECT(RC_KF_SHOP_ITEM_1,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x00,                        GI_SHIELD_DEKU,      "Shop Item 1", "KF Shop Item 1"),
    RC_OBJECT(RC_KF_SHOP_ITEM_2,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x01,                        GI_NUTS_5_2,         "Shop Item 2", "KF Shop Item 2"),
    RC_OBJECT(RC_KF_SHOP_ITEM_3,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x02,                        GI_NUTS_10,          "Shop Item 3", "KF Shop Item 3"),
    RC_OBJECT(RC_KF_SHOP_ITEM_4,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x03,                        GI_STICKS_1,         "Shop Item 4", "KF Shop Item 4"),
    RC_OBJECT(RC_KF_SHOP_ITEM_5,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x04,                        GI_SEEDS_30,         "Shop Item 5", "KF Shop Item 5"),
    RC_OBJECT(RC_KF_SHOP_ITEM_6,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x05,                        GI_ARROWS_SMALL,     "Shop Item 6", "KF Shop Item 6"),
    RC_OBJECT(RC_KF_SHOP_ITEM_7,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x06,                        GI_ARROWS_MEDIUM,    "Shop Item 7", "KF Shop Item 7"),
    RC_OBJECT(RC_KF_SHOP_ITEM_8,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KOKIRI_FOREST,          ACTOR_EN_GIRLA,     SCENE_KOKIRI_SHOP,                    0x07,                        GI_HEART,            "Shop Item 8", "KF Shop Item 8"),
    RC_OBJECT(RC_KF_DEKU_TREE_LEFT_GOSSIP_STONE,                              RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_SPOT04,                         14623,                       GI_NONE,             "Deku Tree Left Gossip Stone", "KF Deku Tree Left Gossip Stone"),
    RC_OBJECT(RC_KF_DEKU_TREE_RIGHT_GOSSIP_STONE,                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_SPOT04,                         14880,                       GI_NONE,             "Deku Tree Right Gossip Stone", "KF Deku Tree Right Gossip Stone"),
    RC_OBJECT(RC_KF_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_SPOT04,                         14366,                       GI_NONE,             "Gossip Stone", "KF Gossip Stone"),
    RC_OBJECT(RC_KF_STORMS_GOSSIP_STONE,                                      RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KOKIRI_FOREST,          ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22988,                      GI_NONE,             "Storms Gossip Stone", "KF Storms Gossip Stone"),


    RC_OBJECT(RC_LW_NEAR_SHORTCUTS_GROTTO_CHEST,                              RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22964,                       GI_RUPEE_BLUE,       "Near Shortcuts Grotto Chest", "LW Near Shortcuts Grotto Chest"),
    RC_OBJECT(RC_LW_SKULL_KID,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_SPOT10,                         0x00,                        GI_NONE,             "Skull Kid", "LW Skull Kid"),
    RC_OBJECT(RC_LW_TRADE_COJIRO,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_SPOT10,                         0x00,                        GI_NONE,             "Trade Cojiro", "LW Trade Cojiro"),
    RC_OBJECT(RC_LW_TRADE_ODD_POTION,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_SPOT10,                         0x00,                        GI_NONE,             "Trade Odd Potion", "LW Trade Odd Potion"),
    RC_OBJECT(RC_LW_OCARINA_MEMORY_GAME,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_SPOT10,                         0x00,                        GI_NONE,             "Ocarina Memory Game", "LW Ocarina Memory Game"),
    RC_OBJECT(RC_LW_TARGET_IN_WOODS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_SPOT10,                         0x00,                        GI_NONE,             "Target in Woods", "LW Target in Woods"),
    RC_OBJECT(RC_LW_DEKU_SCRUB_NEAR_DEKU_THEATER_RIGHT,                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_SPOT10,                         0x00,                        GI_NUTS_5_2,         "Deku Scrub Near Deku Theater Right", "LW Deku Scrub Near Deku Theater Right"),
    RC_OBJECT(RC_LW_DEKU_SCRUB_NEAR_DEKU_THEATER_LEFT,                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_SPOT10,                         0x01,                        GI_STICKS_1,         "Deku Scrub Near Deku Theater Left", "LW Deku Scrub Near Deku Theater Left"),
    RC_OBJECT(RC_LW_DEKU_SCRUB_NEAR_BRIDGE,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_SPOT10,                         0x09,                        GI_STICK_UPGRADE_20, "Deku Scrub Near Bridge", "LW Deku Scrub Near Bridge"),
    RC_OBJECT(RC_LW_DEKU_SCRUB_GROTTO_REAR,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x03,0xF5), GI_SEEDS_30,         "Deku Scrub Grotto Rear", "LW Deku Scrub Grotto Rear"),
    RC_OBJECT(RC_LW_DEKU_SCRUB_GROTTO_FRONT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x0A,0xF5), GI_NUT_UPGRADE_30,   "Deku Scrub Grotto Front", "LW Deku Scrub Grotto Front"),
    RC_OBJECT(RC_DEKU_THEATER_SKULL_MASK,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_KAKUSIANA,                      0x00,                        GI_NONE,             "Deku Theater Skull Mask", "Deku Theater Skull Mask"),
    RC_OBJECT(RC_DEKU_THEATER_MASK_OF_TRUTH,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_KAKUSIANA,                      0x00,                        GI_NONE,             "Deku Theater Mask of Truth", "Deku Theater Mask of Truth"),
    RC_OBJECT(RC_LW_GS_BEAN_PATCH_NEAR_BRIDGE,                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LOST_WOODS,             ACTOR_EN_SI,        SCENE_SPOT10,                         27905,                       GI_SKULL_TOKEN,      "GS Bean Patch Near Bridge", "LW GS Bean Patch Near Bridge"),
    RC_OBJECT(RC_LW_GS_BEAN_PATCH_NEAR_THEATER,                               RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LOST_WOODS,             ACTOR_EN_SI,        SCENE_SPOT10,                         27906,                       GI_SKULL_TOKEN,      "GS Bean Patch Near Theater", "LW GS Bean Patch Near Theater"),
    RC_OBJECT(RC_LW_GS_ABOVE_THEATER,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LOST_WOODS,             ACTOR_EN_SI,        SCENE_SPOT10,                         19716,                       GI_SKULL_TOKEN,      "GS Above Theater", "LW GS Above Theater"),
    RC_OBJECT(RC_LW_GIFT_FROM_SARIA,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LOST_WOODS,             ACTOR_ID_MAX,       SCENE_SPOT10,                         0x00,                        GI_NONE,             "Gift From Saria", "LW Gift From Saria"),
    RC_OBJECT(RC_LW_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LOST_WOODS,             ACTOR_EN_GS,        SCENE_SPOT10,                         14365,                       GI_NONE,             "Gossip Stone", "LW Gossip Stone"),
    RC_OBJECT(RC_LW_NEAR_SHORTCUTS_GOSSIP_STONE,                              RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LOST_WOODS,             ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22964,                      GI_NONE,             "Near Shortcuts Gossip Stone", "LW Near Shortcuts Gossip Stone"),


    RC_OBJECT(RC_SFM_WOLFOS_GROTTO_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      31409,                       GI_RUPEE_PURPLE,     "Wolfos Grotto Chest", "SFM Wolfos Grotto Chest"),
    RC_OBJECT(RC_SFM_DEKU_SCRUB_GROTTO_REAR,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x07,0xEE), GI_POTION_RED,       "Deku Scrub Grotto Rear", "SFM Deku Scrub Grotto Rear"),
    RC_OBJECT(RC_SFM_DEKU_SCRUB_GROTTO_FRONT,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x08,0xEE), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "SFM Deku Scrub Grotto Front"),
    RC_OBJECT(RC_SFM_GS,                                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_SI,        SCENE_SPOT05,                         19720,                       GI_SKULL_TOKEN,      "GS", "SFM GS"),
    RC_OBJECT(RC_SHEIK_IN_FOREST,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SACRED_FOREST_MEADOW,   ACTOR_ID_MAX,       SCENE_SPOT05,                         0x00,                        GI_NONE,             "Sheik in Forest", "Sheik in Forest"),
    RC_OBJECT(RC_SONG_FROM_SARIA,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SACRED_FOREST_MEADOW,   ACTOR_ID_MAX,       SCENE_SPOT05,                         0x00,                        GI_NONE,             "Song from Saria", "Song from Saria"),
    RC_OBJECT(RC_SFM_MAZE_LOWER_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_GS,        SCENE_SPOT05,                         14358,                       GI_NONE,             "Maze Lower Gossip Stone", "SFM Maze Lower Gossip Stone"),
    RC_OBJECT(RC_SFM_MAZE_UPPER_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_GS,        SCENE_SPOT05,                         14615,                       GI_NONE,             "Maze Upper Gossip Stone", "SFM Maze Upper Gossip Stone"),
    RC_OBJECT(RC_SFM_SARIA_GOSSIP_STONE,                                      RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_SACRED_FOREST_MEADOW,   ACTOR_EN_GS,        SCENE_SPOT05,                         14876,                       GI_NONE,             "Saria Gossip Stone", "SFM Saria Gossip Stone"),


    RC_OBJECT(RC_HF_SOUTHEAST_GROTTO_CHEST,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22978,                       GI_RUPEE_RED,        "Southeast Grotto Chest", "HF Southeast Grotto Chest"),
    RC_OBJECT(RC_HF_OPEN_GROTTO_CHEST,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22947,                       GI_RUPEE_BLUE,       "Open Grotto Chest", "HF Open Grotto Chest"),
    RC_OBJECT(RC_HF_NEAR_MARKET_GROTTO_CHEST,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22944,                       GI_RUPEE_BLUE,       "Near Market Grotto Chest", "HF Near Market Grotto Chest"),
    RC_OBJECT(RC_HF_OCARINA_OF_TIME_ITEM,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_ID_MAX,       SCENE_SPOT00,                         0x00,                        GI_NONE,             "Ocarina of Time Item", "HF Ocarina of Time Item"),
    RC_OBJECT(RC_HF_TEKTITE_GROTTO_FREESTANDING_POH,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_EN_ITEM00,    SCENE_KAKUSIANA,                      262,                         GI_HEART_PIECE,      "Tektite Grotto Freestanding PoH", "HF Tektite Grotto Freestanding PoH"),
    RC_OBJECT(RC_HF_DEKU_SCRUB_GROTTO,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x02,0xE6), GI_HEART_PIECE,      "Deku Scrub Grotto", "HF Deku Scrub Grotto"),
    RC_OBJECT(RC_HF_GS_COW_GROTTO,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_HYRULE_FIELD,           ACTOR_EN_SI,        SCENE_KAKUSIANA,                      10753,                       GI_SKULL_TOKEN,      "GS Cow Grotto", "HF GS Cow Grotto"),
    RC_OBJECT(RC_HF_GS_NEAR_KAK_GROTTO,                                       RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_HYRULE_FIELD,           ACTOR_EN_SI,        SCENE_KAKUSIANA,                      10754,                       GI_SKULL_TOKEN,      "GS Near Kak Grotto", "HF GS Near Kak Grotto"),
    RC_OBJECT(RC_SONG_FROM_OCARINA_OF_TIME,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_FIELD,           ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Ocarina of Time", "Song from Ocarina of Time"),
    RC_OBJECT(RC_HF_COW_GROTTO_COW,                                           RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_HYRULE_FIELD,           ACTOR_EN_COW,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(3485,-291), GI_MILK,             "Cow Grotto Cow", "HF Cow Grotto Cow"),
    RC_OBJECT(RC_HF_COW_GROTTO_GOSSIP_STONE,                                  RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_KAKUSIANA,                      14363,                       GI_NONE,             "Cow Grotto Gossip Stone", "HF Cow Grotto Gossip Stone"),
    RC_OBJECT(RC_HF_NEAR_MARKET_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22944,                      GI_NONE,             "Near Market Gossip Stone", "HF Near Market Gossip Stone"),
    RC_OBJECT(RC_HF_OPEN_GROTTO_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22947,                      GI_NONE,             "Open Grotto Gossip Stone", "HF Open Grotto Gossip Stone"),
    RC_OBJECT(RC_HF_SOUTHEAST_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_FIELD,           ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22978,                      GI_NONE,             "Southeast Gossip Stone", "HF Southeast Gossip Stone"),


    RC_OBJECT(RC_LH_CHILD_FISHING,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_TURIBORI,                       0x00,                        GI_NONE,             "Child Fishing", "LH Child Fishing"),
    RC_OBJECT(RC_LH_ADULT_FISHING,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_TURIBORI,                       0x00,                        GI_NONE,             "Adult Fishing", "LH Adult Fishing"),
    RC_OBJECT(RC_LH_LAB_DIVE,                                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_HYLIA_LABO,                     0x00,                        GI_NONE,             "Lab Dive", "LH Lab Dive"),
    RC_OBJECT(RC_LH_TRADE_FROG,                                               RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_HYLIA_LABO,                     0x00,                        GI_NONE,             "Lab Trade Eyeball Frog", "LH Lab Trade Eyeball Frog"),
    RC_OBJECT(RC_LH_UNDERWATER_ITEM,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_SPOT06,                         0x00,                        GI_NONE,             "Underwater Item", "LH Underwater Item"),
    RC_OBJECT(RC_LH_SUN,                                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_ID_MAX,       SCENE_SPOT06,                         0x00,                        GI_NONE,             "Sun", "LH Sun"),
    RC_OBJECT(RC_LH_FREESTANDING_POH,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_EN_ITEM00,    SCENE_SPOT06,                         7686,                        GI_HEART_PIECE,      "Freestanding PoH", "LH Freestanding PoH"),
    RC_OBJECT(RC_LH_DEKU_SCRUB_GROTTO_LEFT,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x00,0xEF), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "LH Deku Scrub Grotto Left"),
    RC_OBJECT(RC_LH_DEKU_SCRUB_GROTTO_RIGHT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x05,0xEF), GI_BOMBS_5,          "Deku Scrub Grotto Right", "LH Deku Scrub Grotto Right"),
    RC_OBJECT(RC_LH_DEKU_SCRUB_GROTTO_CENTER,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LAKE_HYLIA,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x03,0xEF), GI_SEEDS_30,         "Deku Scrub Grotto Center", "LH Deku Scrub Grotto Center"),
    RC_OBJECT(RC_LH_GS_BEAN_PATCH,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_SPOT06,                         29185,                       GI_SKULL_TOKEN,      "GS Bean Patch", "LH GS Bean Patch"),
    RC_OBJECT(RC_LH_GS_SMALL_ISLAND,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_SPOT06,                         20994,                       GI_SKULL_TOKEN,      "GS Small Island", "LH GS Small Island"),
    RC_OBJECT(RC_LH_GS_LAB_WALL,                                              RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_SPOT06,                         20996,                       GI_SKULL_TOKEN,      "GS Lab Wall", "LH GS Lab Wall"),
    RC_OBJECT(RC_LH_GS_LAB_CRATE,                                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_HYLIA_LABO,                     -28152,                      GI_SKULL_TOKEN,      "GS Lab Crate", "LH GS Lab Crate"),
    RC_OBJECT(RC_LH_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LAKE_HYLIA,             ACTOR_EN_SI,        SCENE_SPOT06,                         21008,                       GI_SKULL_TOKEN,      "GS Tree", "LH GS Tree"),
    RC_OBJECT(RC_LH_LAB_GOSSIP_STONE,                                         RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LAKE_HYLIA,             ACTOR_EN_GS,        SCENE_SPOT06,                         14339,                       GI_NONE,             "Lab Gossip Stone", "LH Lab Gossip Stone"),
    RC_OBJECT(RC_LH_SOUTHEAST_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LAKE_HYLIA,             ACTOR_EN_GS,        SCENE_SPOT06,                         14863,                       GI_NONE,             "Southeast Gossip Stone", "LH Southeast Gossip Stone"),
    RC_OBJECT(RC_LH_SOUTHWEST_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_LAKE_HYLIA,             ACTOR_EN_GS,        SCENE_SPOT06,                         14600,                       GI_NONE,             "Southwest Gossip Stone", "LH Southwest Gossip Stone"),


    RC_OBJECT(RC_GV_CHEST,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_BOX,       SCENE_SPOT09,                         23200,                       GI_RUPEE_PURPLE,     "Chest", "GV Chest"),
    RC_OBJECT(RC_GV_TRADE_SAW,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_ID_MAX,       SCENE_SPOT09,                         0x00,                        GI_NONE,             "Trade Saw", "GV Trade Saw"),
    RC_OBJECT(RC_GV_WATERFALL_FREESTANDING_POH,                               RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_ITEM00,    SCENE_SPOT09,                         262,                         GI_HEART_PIECE,      "Waterfall Freestanding PoH", "GV Waterfall Freestanding PoH"),
    RC_OBJECT(RC_GV_CRATE_FREESTANDING_POH,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_ITEM00,    SCENE_SPOT09,                         518,                         GI_HEART_PIECE,      "Crate Freestanding PoH", "GV Crate Freestanding PoH"),
    RC_OBJECT(RC_GV_DEKU_SCRUB_GROTTO_REAR,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x07,0xF0), GI_POTION_RED,       "Deku Scrub Grotto Rear", "GV Deku Scrub Grotto Rear"),
    RC_OBJECT(RC_GV_DEKU_SCRUB_GROTTO_FRONT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_VALLEY,          ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x08,0xF0), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "GV Deku Scrub Grotto Front"),
    RC_OBJECT(RC_GV_GS_BEAN_PATCH,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_SPOT09,                         29441,                       GI_SKULL_TOKEN,      "GS Bean Patch", "GV GS Bean Patch"),
    RC_OBJECT(RC_GV_GS_SMALL_BRIDGE,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_SPOT09,                         21250,                       GI_SKULL_TOKEN,      "GS Small Bridge", "GV GS Small Bridge"),
    RC_OBJECT(RC_GV_GS_PILLAR,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_SPOT09,                         21252,                       GI_SKULL_TOKEN,      "GS Pillar", "GV GS Pillar"),
    RC_OBJECT(RC_GV_GS_BEHIND_TENT,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_VALLEY,          ACTOR_EN_SI,        SCENE_SPOT09,                         21256,                       GI_SKULL_TOKEN,      "GS Behind Tent", "GV GS Behind Tent"),
    RC_OBJECT(RC_GV_COW,                                                      RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_GERUDO_VALLEY,          ACTOR_EN_COW,       SCENE_SPOT09,                         0x00,                        GI_MILK,             "Cow", "GV Cow"),
    RC_OBJECT(RC_GV_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GERUDO_VALLEY,          ACTOR_EN_GS,        SCENE_SPOT09,                         14353,                       GI_NONE,             "Gossip Stone", "GV Gossip Stone"),


    RC_OBJECT(RC_GF_CHEST,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_EN_BOX,       SCENE_SPOT12,                         1984,                        GI_HEART_PIECE,      "Chest", "GF Chest"),
    RC_OBJECT(RC_GF_HBA_1000_POINTS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_ID_MAX,       SCENE_SPOT12,                         0x00,                        GI_NONE,             "GF HBA 1000 Points", "GF HBA 1000 Points"),
    RC_OBJECT(RC_GF_HBA_1500_POINTS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_ID_MAX,       SCENE_SPOT12,                         0x00,                        GI_NONE,             "GF HBA 1500 Points", "GF HBA 1500 Points"),
    RC_OBJECT(RC_GF_GERUDO_MEMBERSHIP_CARD,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_ID_MAX,       SCENE_GERUDOWAY,                      0x00,                        GI_NONE,             "GF Gerudo Membership Card", "GF Gerudo Membership Card"),
    RC_OBJECT(RC_GF_NORTH_F1_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_GERUDOWAY,                      3089,                        GI_KEY_SMALL,        "GF North F1 Carpenter", "GF North F1 Carpenter"),
    RC_OBJECT(RC_GF_NORTH_F2_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_GERUDOWAY,                      2577,                        GI_KEY_SMALL,        "GF North F2 Carpenter", "GF North F2 Carpenter"),
    RC_OBJECT(RC_GF_SOUTH_F1_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_GERUDOWAY,                      3601,                        GI_KEY_SMALL,        "GF South F1 Carpenter", "GF South F1 Carpenter"),
    RC_OBJECT(RC_GF_SOUTH_F2_CARPENTER,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GERUDO_FORTRESS,        ACTOR_EN_ITEM00,    SCENE_GERUDOWAY,                      3857,                        GI_KEY_SMALL,        "GF South F2 Carpenter", "GF South F2 Carpenter"),
    RC_OBJECT(RC_GF_GS_ARCHERY_RANGE,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_FORTRESS,        ACTOR_EN_SI,        SCENE_SPOT12,                         21505,                       GI_SKULL_TOKEN,      "GS Archery Range", "GF GS Archery Range"),
    RC_OBJECT(RC_GF_GS_TOP_FLOOR,                                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GERUDO_FORTRESS,        ACTOR_EN_SI,        SCENE_SPOT12,                         21506,                       GI_SKULL_TOKEN,      "GS Top Floor", "GF GS Top Floor"),


    RC_OBJECT(RC_WASTELAND_CHEST,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_WASTELAND,              ACTOR_EN_BOX,       SCENE_SPOT13,                         -30048,                      GI_RUPEE_PURPLE,     "Chest", "Wasteland Chest"),
    RC_OBJECT(RC_WASTELAND_BOMBCHU_SALESMAN,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_WASTELAND,              ACTOR_ID_MAX,       SCENE_SPOT13,                         0x00,                        GI_NONE,             "Carpet Salesman", "Wasteland Carpet Salesman"),
    RC_OBJECT(RC_WASTELAND_GS,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_WASTELAND,              ACTOR_EN_SI,        SCENE_SPOT13,                         13570,                       GI_SKULL_TOKEN,      "GS", "Wasteland GS"),


    RC_OBJECT(RC_COLOSSUS_FREESTANDING_POH,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DESERT_COLOSSUS,        ACTOR_EN_ITEM00,    SCENE_SPOT11,                         3334,                        GI_HEART_PIECE,      "Freestanding PoH", "Colossus Freestanding PoH"),
    RC_OBJECT(RC_COLOSSUS_DEKU_SCRUB_GROTTO_REAR,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DESERT_COLOSSUS,        ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x07,0xFD), GI_POTION_RED,       "Deku Scrub Grotto Rear", "Colossus Deku Scrub Grotto Rear"),
    RC_OBJECT(RC_COLOSSUS_DEKU_SCRUB_GROTTO_FRONT,                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DESERT_COLOSSUS,        ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x08,0xFD), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "Colossus Deku Scrub Grotto Front"),
    RC_OBJECT(RC_COLOSSUS_GS_BEAN_PATCH,                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DESERT_COLOSSUS,        ACTOR_EN_SI,        SCENE_SPOT11,                         29953,                       GI_SKULL_TOKEN,      "GS Bean Patch", "Colossus GS Bean Patch"),
    RC_OBJECT(RC_COLOSSUS_GS_HILL,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DESERT_COLOSSUS,        ACTOR_EN_SI,        SCENE_SPOT11,                         21764,                       GI_SKULL_TOKEN,      "GS Hill", "Colossus GS Hill"),
    RC_OBJECT(RC_COLOSSUS_GS_TREE,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DESERT_COLOSSUS,        ACTOR_EN_SI,        SCENE_SPOT11,                         21768,                       GI_SKULL_TOKEN,      "GS Tree", "Colossus GS Tree"),
    RC_OBJECT(RC_COLOSSUS_GREAT_FAIRY_REWARD,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DESERT_COLOSSUS,        ACTOR_BG_DY_YOSEIZO,SCENE_YOUSEI_IZUMI_YOKO,              3,                           GI_NONE,             "Great Fairy Reward", "Colossus Great Fairy Reward"),
    RC_OBJECT(RC_SHEIK_AT_COLOSSUS,                                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DESERT_COLOSSUS,        ACTOR_ID_MAX,       SCENE_SPOT11,                         0x00,                        GI_NONE,             "Sheik at Colossus", "Sheik at Colossus"),
    RC_OBJECT(RC_COLOSSUS_GOSSIP_STONE,                                       RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DESERT_COLOSSUS,        ACTOR_EN_GS,        SCENE_SPOT11,                         14362,                       GI_NONE,             "Gossip Stone", "Colossus Gossip Stone"),


    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_REWARD,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TAKARAYA,                       0x00,                        GI_NONE,             "Treasure Chest Game Reward", "MK Treasure Chest Game Reward"),
    RC_OBJECT(RC_MARKET_BOMBCHU_BOWLING_FIRST_PRIZE,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_BOWLING,                        0x00,                        GI_NONE,             "Bombchu Bowling First Prize", "MK Bombchu Bowling First Prize"),
    RC_OBJECT(RC_MARKET_BOMBCHU_BOWLING_SECOND_PRIZE,                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_BOWLING,                        0x00,                        GI_NONE,             "Bombchu Bowling Second Prize", "MK Bombchu Bowling Second Prize"),
    RC_OBJECT(RC_MARKET_LOST_DOG,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_IMPA,                           0x00,                        GI_NONE,             "Lost Dog", "MK Lost Dog"),
    RC_OBJECT(RC_MARKET_SHOOTING_GALLERY_REWARD,                              RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_SYATEKIJYOU,                    0x00,                        GI_NONE,             "Shooting Gallery", "MK Shooting Gallery"),
    RC_OBJECT(RC_MARKET_10_BIG_POES,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_MIHARIGOYA,                     0x00,                        GI_NONE,             "10 Big Poes", "MK 10 Big Poes"),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_1,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,   RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TAKARAYA,                       0x00,                        GI_NONE,             "Chest Game First Room Chest", "MK Chest Game First Room Chest"),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_2,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,   RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TAKARAYA,                       0x00,                        GI_NONE,             "Chest Game Second Room Chest", "MK Chest Game Second Room Chest"),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_3,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,   RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TAKARAYA,                       0x00,                        GI_NONE,             "Chest Game Third Room Chest", "MK Chest Game Third Room Chest"),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_4,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,   RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TAKARAYA,                       0x00,                        GI_NONE,             "Chest Game Fourth Room Chest", "MK Chest Game Fourth Room Chest"),
    RC_OBJECT(RC_MARKET_TREASURE_CHEST_GAME_ITEM_5,                           RCVORMQ_BOTH,    RCTYPE_CHEST_GAME,   RCAREA_MARKET,                 ACTOR_EN_BOX,       SCENE_TAKARAYA,                       0x00,                        GI_NONE,             "Chest Game Fifth Room Chest", "MK Chest Game Fifth Room Chest"),
    RC_OBJECT(RC_MARKET_GS_GUARD_HOUSE,                                       RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_MARKET,                 ACTOR_EN_SI,        SCENE_MIHARIGOYA,                     -29176,                      GI_SKULL_TOKEN,      "Market GS Guard House", "Market GS Guard House"),
    RC_OBJECT(RC_TOT_LIGHT_ARROWS_CUTSCENE,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Light Arrow Cutscene", "ToT Light Arrow Cutscene"),
    RC_OBJECT(RC_SHEIK_AT_TEMPLE,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_MARKET,                 ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Sheik at Temple", "Sheik at Temple"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_1,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x00,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 1", "MK Bombchu Shop Item 1"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_2,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x01,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 2", "MK Bombchu Shop Item 2"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_3,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x02,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 3", "MK Bombchu Shop Item 3"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_4,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x03,                        GI_BOMBCHUS_10,      "Bombchu Shop Item 4", "MK Bombchu Shop Item 4"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_5,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x04,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 5", "MK Bombchu Shop Item 5"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_6,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x05,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 6", "MK Bombchu Shop Item 6"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_7,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x06,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 7", "MK Bombchu Shop Item 7"),
    RC_OBJECT(RC_MARKET_BOMBCHU_SHOP_ITEM_8,                                  RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_NIGHT_SHOP,                     0x07,                        GI_BOMBCHUS_20,      "Bombchu Shop Item 8", "MK Bombchu Shop Item 8"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_1,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x00,                        GI_POTION_GREEN,     "Potion Shop Item 1", "MK Potion Shop Item 1"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_2,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x01,                        GI_BLUE_FIRE,        "Potion Shop Item 2", "MK Potion Shop Item 2"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_3,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x02,                        GI_POTION_RED,       "Potion Shop Item 3", "MK Potion Shop Item 3"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_4,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x03,                        GI_FAIRY,            "Potion Shop Item 4", "MK Potion Shop Item 4"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_5,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x04,                        GI_NUTS_5_2,         "Potion Shop Item 5", "MK Potion Shop Item 5"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_6,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x05,                        GI_BUGS,             "Potion Shop Item 6", "MK Potion Shop Item 6"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_7,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x06,                        GI_POE,              "Potion Shop Item 7", "MK Potion Shop Item 7"),
    RC_OBJECT(RC_MARKET_POTION_SHOP_ITEM_8,                                   RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_ALLEY_SHOP,                     0x07,                        GI_FISH,             "Potion Shop Item 8", "MK Potion Shop Item 8"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_1,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x00,                        GI_SHIELD_HYLIAN,    "Bazaar Item 1", "MK Bazaar Item 1"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_2,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x01,                        GI_BOMBS_5,          "Bazaar Item 2", "MK Bazaar Item 2"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_3,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x02,                        GI_NUTS_5_2,         "Bazaar Item 3", "MK Bazaar Item 3"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_4,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x03,                        GI_HEART,            "Bazaar Item 4", "MK Bazaar Item 4"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_5,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x04,                        GI_ARROWS_SMALL,     "Bazaar Item 5", "MK Bazaar Item 5"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_6,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x05,                        GI_ARROWS_LARGE,     "Bazaar Item 6", "MK Bazaar Item 6"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_7,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x06,                        GI_STICKS_1,         "Bazaar Item 7", "MK Bazaar Item 7"),
    RC_OBJECT(RC_MARKET_BAZAAR_ITEM_8,                                        RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_MARKET,                 ACTOR_EN_GIRLA,     SCENE_SHOP1,                          0x07,                        GI_ARROWS_MEDIUM,    "Bazaar Item 8", "MK Bazaar Item 8"),
    RC_OBJECT(RC_TOT_LEFT_CENTER_GOSSIP_STONE,                                RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Left Center Gossip Stone", "ToT Left Center Gossip Stone"),
    RC_OBJECT(RC_TOT_LEFT_GOSSIP_STONE,                                       RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Left Gossip Stone", "ToT Left Gossip Stone"),
    RC_OBJECT(RC_TOT_RIGHT_CENTER_GOSSIP_STONE,                               RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Right Center Gossip Stone", "ToT Right Center Gossip Stone"),
    RC_OBJECT(RC_TOT_RIGHT_GOSSIP_STONE,                                      RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_MARKET,                 ACTOR_EN_GS,        SCENE_ID_MAX,                         0x00,                        GI_NONE,             "ToT Right Gossip Stone", "ToT Right Gossip Stone"),


    RC_OBJECT(RC_HC_MALON_EGG,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_CASTLE,          ACTOR_ID_MAX,       SCENE_SPOT15,                         0x00,                        GI_NONE,             "Malon Egg", "HC Malon Egg"),
    RC_OBJECT(RC_HC_ZELDAS_LETTER,                                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_CASTLE,          ACTOR_ID_MAX,       SCENE_NAKANIWA,                       0x00,                        GI_NONE,             "Zeldas Letter", "HC Zeldas Letter"),
    RC_OBJECT(RC_OGC_GS,                                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_HYRULE_CASTLE,          ACTOR_EN_SI,        SCENE_GANON_TOU,                      11777,                       GI_SKULL_TOKEN,      "OGC GS", "OGC GS"),
    RC_OBJECT(RC_HC_GS_STORMS_GROTTO,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_HYRULE_CASTLE,          ACTOR_EN_SI,        SCENE_KAKUSIANA,                      11778,                       GI_SKULL_TOKEN,      "GS Storms Grotto", "HC GS Storms Grotto"),
    RC_OBJECT(RC_HC_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_HYRULE_CASTLE,          ACTOR_EN_SI,        SCENE_SPOT15,                         -29180,                      GI_SKULL_TOKEN,      "GS Tree", "HC GS Tree"),
    RC_OBJECT(RC_HC_GREAT_FAIRY_REWARD,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_CASTLE,          ACTOR_BG_DY_YOSEIZO,SCENE_YOUSEI_IZUMI_YOKO,              2,                           GI_NONE,             "Great Fairy Reward", "HC Great Fairy Reward"),
    RC_OBJECT(RC_OGC_GREAT_FAIRY_REWARD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_CASTLE,          ACTOR_BG_DY_YOSEIZO,SCENE_DAIYOUSEI_IZUMI,                3,                           GI_NONE,             "OGC Great Fairy Reward", "OGC Great Fairy Reward"),
    RC_OBJECT(RC_SONG_FROM_IMPA,                                              RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_HYRULE_CASTLE,          ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Impa", "Song from Impa"),
    RC_OBJECT(RC_HC_MALON_GOSSIP_STONE,                                       RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_CASTLE,          ACTOR_EN_GS,        SCENE_SPOT15,                         14610,                       GI_NONE,             "Malon Gossip Stone", "HC Malon Gossip Stone"),
    RC_OBJECT(RC_HC_ROCK_WALL_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_CASTLE,          ACTOR_EN_GS,        SCENE_SPOT15,                         14347,                       GI_NONE,             "Rock Wall Gossip Stone", "HC Rock Wall Gossip Stone"),
    RC_OBJECT(RC_HC_STORMS_GROTTO_GOSSIP_STONE,                               RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_HYRULE_CASTLE,          ACTOR_EN_GS,        SCENE_KAKUSIANA,                      14355,                       GI_NONE,             "Storms Grotto Gossip Stone", "HC Storms Grotto Gossip Stone"),


    RC_OBJECT(RC_KAK_REDEAD_GROTTO_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      31434,                       GI_RUPEE_GOLD,       "Redead Grotto Chest", "Kak Redead Grotto Chest"),
    RC_OBJECT(RC_KAK_OPEN_GROTTO_CHEST,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22984,                       GI_RUPEE_RED,        "Open Grotto Chest", "Kak Open Grotto Chest"),
    RC_OBJECT(RC_KAK_10_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KINSUTA,                        0x00,                        GI_NONE,             "10 Gold Skulltula Reward", "Kak 10 Gold Skulltula Reward"),
    RC_OBJECT(RC_KAK_20_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KINSUTA,                        0x00,                        GI_NONE,             "20 Gold Skulltula Reward", "Kak 20 Gold Skulltula Reward"),
    RC_OBJECT(RC_KAK_30_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KINSUTA,                        0x00,                        GI_NONE,             "30 Gold Skulltula Reward", "Kak 30 Gold Skulltula Reward"),
    RC_OBJECT(RC_KAK_40_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KINSUTA,                        0x00,                        GI_NONE,             "40 Gold Skulltula Reward", "Kak 40 Gold Skulltula Reward"),
    RC_OBJECT(RC_KAK_50_GOLD_SKULLTULA_REWARD,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_KINSUTA,                        0x00,                        GI_NONE,             "50 Gold Skulltula Reward", "Kak 50 Gold Skulltula Reward"),
    RC_OBJECT(RC_KAK_MAN_ON_ROOF,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_SPOT01,                         0x00,                        GI_NONE,             "Man on Roof", "Kak Man on Roof"),
    RC_OBJECT(RC_KAK_SHOOTING_GALLERY_REWARD,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_SYATEKIJYOU,                    0x00,                        GI_NONE,             "Shooting Gallery Reward", "Kak Shooting Gallery Reward"),
    RC_OBJECT(RC_KAK_TRADE_ODD_MUSHROOM,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_MAHOUYA,                        0x00,                        GI_NONE,             "Trade Odd Mushroom", "Kak Trade Odd Mushroom"),
    RC_OBJECT(RC_KAK_ANJU_AS_ADULT,                                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_SPOT01,                         0x00,                        GI_NONE,             "Anju as Adult", "Kak Anju as Adult"),
    RC_OBJECT(RC_KAK_ANJU_AS_CHILD,                                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_SPOT01,                         0x00,                        GI_NONE,             "Anju as Child", "Kak Anju as Child"),
    RC_OBJECT(RC_KAK_TRADE_POCKET_CUCCO,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_SPOT01,                         0x00,                        GI_NONE,             "Trade Pocket Cucco", "Kak Trade Pocket Cucco"),
    RC_OBJECT(RC_KAK_IMPAS_HOUSE_FREESTANDING_POH,                            RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_ITEM00,    SCENE_LABO,                           262,                         GI_HEART_PIECE,      "Impas House Freestanding PoH", "Kak Impas House Freestanding PoH"),
    RC_OBJECT(RC_KAK_WINDMILL_FREESTANDING_POH,                               RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_ITEM00,    SCENE_HAKASITARELAY,                  262,                         GI_HEART_PIECE,      "Windmill Freestanding PoH", "Kak Windmill Freestanding PoH"),
    RC_OBJECT(RC_KAK_GS_HOUSE_UNDER_CONSTRUCTION,                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_SPOT01,                         20488,                       GI_SKULL_TOKEN,      "GS House Under Construction", "Kak GS House Under Construction"),
    RC_OBJECT(RC_KAK_GS_SKULLTULA_HOUSE,                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_SPOT01,                         20496,                       GI_SKULL_TOKEN,      "GS Skulltula House", "Kak GS Skulltula House"),
    RC_OBJECT(RC_KAK_GS_GUARDS_HOUSE,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_SPOT01,                         20482,                       GI_SKULL_TOKEN,      "GS Guards House", "Kak GS Guards House"),
    RC_OBJECT(RC_KAK_GS_TREE,                                                 RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_SPOT01,                         -28640,                      GI_SKULL_TOKEN,      "GS Tree", "Kak GS Tree"),
    RC_OBJECT(RC_KAK_GS_WATCHTOWER,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_SPOT01,                         20484,                       GI_SKULL_TOKEN,      "GS Watchtower", "Kak GS Watchtower"),
    RC_OBJECT(RC_KAK_GS_ABOVE_IMPAS_HOUSE,                                    RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_SI,        SCENE_SPOT01,                         20544,                       GI_SKULL_TOKEN,      "GS Above Impas House", "Kak GS Above Impas House"),
    RC_OBJECT(RC_SHEIK_IN_KAKARIKO,                                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Sheik in Kakariko", "Sheik in Kakariko"),
    RC_OBJECT(RC_SONG_FROM_WINDMILL,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_KAKARIKO_VILLAGE,       ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Windmill", "Song from Windmill"),
    RC_OBJECT(RC_KAK_IMPAS_HOUSE_COW,                                         RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_COW,       SCENE_LABO,                           0x00,                        GI_MILK,             "Impas House Cow", "Kak Impas House Cow"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_1,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x00,                        GI_POTION_GREEN,     "Potion Shop Item 1", "Kak Potion Shop Item 1"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_2,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x01,                        GI_BLUE_FIRE,        "Potion Shop Item 2", "Kak Potion Shop Item 2"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_3,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x02,                        GI_POTION_RED,       "Potion Shop Item 3", "Kak Potion Shop Item 3"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_4,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x03,                        GI_FAIRY,            "Potion Shop Item 4", "Kak Potion Shop Item 4"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_5,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x04,                        GI_NUTS_5_2,         "Potion Shop Item 5", "Kak Potion Shop Item 5"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_6,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x05,                        GI_BUGS,             "Potion Shop Item 6", "Kak Potion Shop Item 6"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_7,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x06,                        GI_POE,              "Potion Shop Item 7", "Kak Potion Shop Item 7"),
    RC_OBJECT(RC_KAK_POTION_SHOP_ITEM_8,                                      RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_DRAG,                           0x07,                        GI_FISH,             "Potion Shop Item 8", "Kak Potion Shop Item 8"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_1,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x00,                        GI_SHIELD_HYLIAN,    "Bazaar Item 1", "Kak Bazaar Item 1"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_2,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x01,                        GI_BOMBS_5,          "Bazaar Item 2", "Kak Bazaar Item 2"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_3,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x02,                        GI_NUTS_5_2,         "Bazaar Item 3", "Kak Bazaar Item 3"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_4,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x03,                        GI_HEART,            "Bazaar Item 4", "Kak Bazaar Item 4"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_5,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x04,                        GI_ARROWS_SMALL,     "Bazaar Item 5", "Kak Bazaar Item 5"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_6,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x05,                        GI_ARROWS_LARGE,     "Bazaar Item 6", "Kak Bazaar Item 6"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_7,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x06,                        GI_STICKS_1,         "Bazaar Item 7", "Kak Bazaar Item 7"),
    RC_OBJECT(RC_KAK_BAZAAR_ITEM_8,                                           RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GIRLA,     SCENE_TEST01,                         0x07,                        GI_ARROWS_MEDIUM,    "Bazaar Item 8", "Kak Bazaar Item 8"),
    RC_OBJECT(RC_KAK_OPEN_GROTTO_GOSSIP_STONE,                                RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_KAKARIKO_VILLAGE,       ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22984,                      GI_NONE,             "Open Grotto Gossip Stone", "Kak Open Grotto Gossip Stone"),


    RC_OBJECT(RC_GRAVEYARD_SHIELD_GRAVE_CHEST,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_HAKAANA2,                       21824,                       GI_SHIELD_HYLIAN,    "Shield Grave Chest", "GY Shield Grave Chest"),
    RC_OBJECT(RC_GRAVEYARD_HEART_PIECE_GRAVE_CHEST,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_HAKAANA,                        -22592,                      GI_HEART_PIECE,      "Heart Piece Grave Chest", "GY Heart Piece Grave Chest"),
    RC_OBJECT(RC_GRAVEYARD_ROYAL_FAMILYS_TOMB_CHEST,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_HAKAANA_OUKE,                   -32736,                      GI_BOMBS_5,          "Composers Grave Chest", "GY Composers Grave Chest"),
    RC_OBJECT(RC_GRAVEYARD_HOOKSHOT_CHEST,                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_BOX,       SCENE_HAKASITARELAY,                  4352,                        GI_HOOKSHOT,         "Hookshot Chest", "GY Hookshot Chest"),
    RC_OBJECT(RC_GRAVEYARD_DAMPE_RACE_FREESTANDING_POH,                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_ITEM00,    SCENE_HAKASITARELAY,                  1798,                        GI_HEART_PIECE,      "Dampe Race Freestanding PoH", "GY Dampe Race Freestanding PoH"),
    RC_OBJECT(RC_GRAVEYARD_FREESTANDING_POH,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_ITEM00,    SCENE_SPOT02,                         1030,                        GI_HEART_PIECE,      "Freestanding PoH", "GY Freestanding PoH"),
    RC_OBJECT(RC_GRAVEYARD_DAMPE_GRAVEDIGGING_TOUR,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_EN_ITEM00,    SCENE_SPOT02,                         7942,                        GI_HEART_PIECE,      "Dampe Gravedigging Tour", "GY Dampe Gravedigging Tour"),
    RC_OBJECT(RC_GRAVEYARD_GS_WALL,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GRAVEYARD,              ACTOR_EN_SI,        SCENE_SPOT02,                         20608,                       GI_SKULL_TOKEN,      "GS Wall", "Graveyard GS Wall"),
    RC_OBJECT(RC_GRAVEYARD_GS_BEAN_PATCH,                                     RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GRAVEYARD,              ACTOR_EN_SI,        SCENE_SPOT02,                         28673,                       GI_SKULL_TOKEN,      "GS Bean Patch", "Graveyard GS Bean Patch"),
    RC_OBJECT(RC_SONG_FROM_ROYAL_FAMILYS_TOMB,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GRAVEYARD,              ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Composers Grave", "Song from Composers Grave"),
    RC_OBJECT(RC_GY_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GRAVEYARD,              ACTOR_EN_GS,        SCENE_SPOT02,                         14346,                       GI_NONE,             "Gossip Stone", "GY Gossip Stone"),


    RC_OBJECT(RC_DMT_CHEST,                                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_BOX,       SCENE_SPOT16,                         23201,                       GI_RUPEE_PURPLE,     "Chest", "DMT Chest"),
    RC_OBJECT(RC_DMT_STORMS_GROTTO_CHEST,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      23255,                       GI_RUPEE_GOLD,       "Storms Grotto Chest", "DMT Storms Grotto Chest"),
    RC_OBJECT(RC_DMT_TRADE_BROKEN_SWORD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_ID_MAX,       SCENE_SPOT16,                         0x00,                        GI_NONE,             "Trade Broken Sword", "DMT Trade Broken Sword"),
    RC_OBJECT(RC_DMT_TRADE_EYEDROPS,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_ID_MAX,       SCENE_SPOT16,                         0x00,                        GI_NONE,             "Trade Eyedrops", "DMT Trade Eyedrops"),
    RC_OBJECT(RC_DMT_TRADE_CLAIM_CHECK,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_ID_MAX,       SCENE_SPOT16,                         0x00,                        GI_NONE,             "Trade Claim Check", "DMT Trade Claim Check"),
    RC_OBJECT(RC_DMT_FREESTANDING_POH,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_ITEM00,    SCENE_SPOT16,                         7686,                        GI_HEART_PIECE,      "Freestanding PoH", "DMT Freestanding PoH"),
    RC_OBJECT(RC_DMT_GS_BEAN_PATCH,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_SPOT16,                         28418,                       GI_SKULL_TOKEN,      "GS Bean Patch", "DMT GS Bean Patch"),
    RC_OBJECT(RC_DMT_GS_NEAR_KAK,                                             RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_SPOT16,                         12036,                       GI_SKULL_TOKEN,      "GS Near Kak", "DMT GS Near Kak"),
    RC_OBJECT(RC_DMT_GS_ABOVE_DODONGOS_CAVERN,                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_SPOT16,                         20232,                       GI_SKULL_TOKEN,      "GS Above Dodongos Cavern", "DMT GS Above Dodongos Cavern"),
    RC_OBJECT(RC_DMT_GS_FALLING_ROCKS_PATH,                                   RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_SI,        SCENE_SPOT16,                         20240,                       GI_SKULL_TOKEN,      "GS Falling Rocks Path", "DMT GS Falling Rocks Path"),
    RC_OBJECT(RC_DMT_GREAT_FAIRY_REWARD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_BG_DY_YOSEIZO,SCENE_DAIYOUSEI_IZUMI,                1,                           GI_NONE,             "Great Fairy Reward", "DMT Great Fairy Reward"),
    RC_OBJECT(RC_DMT_COW_GROTTO_COW,                                          RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_COW,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(2444,-471), GI_MILK,             "Cow Grotto Cow", "DMT Cow Grotto Cow"),
    RC_OBJECT(RC_DMT_GOSSIP_STONE,                                            RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_GS,        SCENE_SPOT16,                         14340,                       GI_NONE,             "Gossip Stone", "DMT Gossip Stone"),
    RC_OBJECT(RC_DMT_STORMS_GROTTO_GOSSIP_STONE,                              RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DEATH_MOUNTAIN_TRAIL,   ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -23255,                      GI_NONE,             "Storms Grotto Gossip Stone", "DMT Storms Grotto Gossip Stone"),


    RC_OBJECT(RC_GC_MAZE_LEFT_CHEST,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_BOX,       SCENE_SPOT18,                         23232,                       GI_RUPEE_GOLD,       "Maze Left Chest", "GC Maze Left Chest"),
    RC_OBJECT(RC_GC_MAZE_RIGHT_CHEST,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_BOX,       SCENE_SPOT18,                         23201,                       GI_RUPEE_PURPLE,     "Maze Right Chest", "GC Maze Right Chest"),
    RC_OBJECT(RC_GC_MAZE_CENTER_CHEST,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_BOX,       SCENE_SPOT18,                         23202,                       GI_RUPEE_PURPLE,     "Maze Center Chest", "GC Maze Center Chest"),
    RC_OBJECT(RC_GC_ROLLING_GORON_AS_CHILD,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_SPOT18,                         0x00,                        GI_NONE,             "Rolling Goron as Child", "GC Rolling Goron as Child"),
    RC_OBJECT(RC_GC_ROLLING_GORON_AS_ADULT,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_SPOT18,                         0x00,                        GI_NONE,             "Rolling Goron as Adult", "GC Rolling Goron as Adult"),
    RC_OBJECT(RC_GC_DARUNIAS_JOY,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_SPOT18,                         0x00,                        GI_NONE,             "Darunias Joy", "GC Darunias Joy"),
    RC_OBJECT(RC_GC_POT_FREESTANDING_POH,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_ITEM00,    SCENE_SPOT18,                         7942,                        GI_HEART_PIECE,      "Pot Freestanding PoH", "GC Pot Freestanding PoH"),
    RC_OBJECT(RC_GC_DEKU_SCRUB_GROTTO_LEFT,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x00,0xFB), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "GC Deku Scrub Grotto Left"),
    RC_OBJECT(RC_GC_DEKU_SCRUB_GROTTO_RIGHT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x05,0xFB), GI_BOMBS_5,          "Deku Scrub Grotto Right", "GC Deku Scrub Grotto Right"),
    RC_OBJECT(RC_GC_DEKU_SCRUB_GROTTO_CENTER,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x03,0xFB), GI_SEEDS_30,         "Deku Scrub Grotto Center", "GC Deku Scrub Grotto Center"),
    RC_OBJECT(RC_GC_MEDIGORON,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_GORON_CITY,             ACTOR_ID_MAX,       SCENE_SPOT18,                         0x00,                        GI_NONE,             "Medigoron", "GC Medigoron"),
    RC_OBJECT(RC_GC_GS_CENTER_PLATFORM,                                       RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GORON_CITY,             ACTOR_EN_SI,        SCENE_SPOT18,                         12064,                       GI_SKULL_TOKEN,      "GS Center Platform", "GC GS Center Platform"),
    RC_OBJECT(RC_GC_GS_BOULDER_MAZE,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_GORON_CITY,             ACTOR_EN_SI,        SCENE_SPOT18,                         -28864,                      GI_SKULL_TOKEN,      "GS Boulder Maze", "GC GS Boulder Maze"),
    RC_OBJECT(RC_GC_SHOP_ITEM_1,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x00,                        GI_BOMBS_5,          "Shop Item 1", "GC Shop Item 1"),
    RC_OBJECT(RC_GC_SHOP_ITEM_2,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x01,                        GI_BOMBS_10,         "Shop Item 2", "GC Shop Item 2"),
    RC_OBJECT(RC_GC_SHOP_ITEM_3,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x02,                        GI_BOMBS_20,         "Shop Item 3", "GC Shop Item 3"),
    RC_OBJECT(RC_GC_SHOP_ITEM_4,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x03,                        GI_BOMBS_30,         "Shop Item 4", "GC Shop Item 4"),
    RC_OBJECT(RC_GC_SHOP_ITEM_5,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x04,                        GI_TUNIC_GORON,      "Shop Item 5", "GC Shop Item 5"),
    RC_OBJECT(RC_GC_SHOP_ITEM_6,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x05,                        GI_HEART,            "Shop Item 6", "GC Shop Item 6"),
    RC_OBJECT(RC_GC_SHOP_ITEM_7,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x06,                        GI_POTION_RED,       "Shop Item 7", "GC Shop Item 7"),
    RC_OBJECT(RC_GC_SHOP_ITEM_8,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_GORON_CITY,             ACTOR_EN_GIRLA,     SCENE_GOLON,                          0x07,                        GI_HEART,            "Shop Item 8", "GC Shop Item 8"),
    RC_OBJECT(RC_GC_MAZE_GOSSIP_STONE,                                        RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GORON_CITY,             ACTOR_EN_GS,        SCENE_SPOT18,                         14357,                       GI_NONE,             "Maze Gossip Stone", "GC Maze Gossip Stone"),
    RC_OBJECT(RC_GC_MEDIGORON_GOSSIP_STONE,                                   RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_GORON_CITY,             ACTOR_EN_GS,        SCENE_SPOT18,                         14873,                       GI_NONE,             "Medigoron Gossip Stone", "GC Medigoron Gossip Stone"),


    RC_OBJECT(RC_DMC_UPPER_GROTTO_CHEST,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      23802,                       GI_BOMBS_20,         "Upper Grotto Chest", "DMC Upper Grotto Chest"),
    RC_OBJECT(RC_DMC_WALL_FREESTANDING_POH,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_ITEM00,    SCENE_SPOT17,                         518,                         GI_HEART_PIECE,      "Wall Freestanding PoH", "DMC Wall Freestanding PoH"),
    RC_OBJECT(RC_DMC_VOLCANO_FREESTANDING_POH,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_ITEM00,    SCENE_SPOT17,                         2054,                        GI_HEART_PIECE,      "Volcano Freestanding PoH", "DMC Volcano Freestanding PoH"),
    RC_OBJECT(RC_DMC_DEKU_SCRUB,                                              RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_SPOT17,                         0x05,                        GI_BOMBS_5,          "Deku Scrub", "DMC Deku Scrub"),
    RC_OBJECT(RC_DMC_DEKU_SCRUB_GROTTO_LEFT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x00,0xF9), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "DMC Deku Scrub Grotto Left"),
    RC_OBJECT(RC_DMC_DEKU_SCRUB_GROTTO_RIGHT,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x05,0xF9), GI_BOMBS_5,          "Deku Scrub Grotto Right", "DMC Deku Scrub Grotto Right"),
    RC_OBJECT(RC_DMC_DEKU_SCRUB_GROTTO_CENTER,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x03,0xF9), GI_SEEDS_30,         "Deku Scrub Grotto Center", "DMC Deku Scrub Grotto Center"),
    RC_OBJECT(RC_DMC_GS_BEAN_PATCH,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_SI,        SCENE_SPOT17,                         28417,                       GI_SKULL_TOKEN,      "GS Bean Patch", "DMC GS Bean Patch"),
    RC_OBJECT(RC_DMC_GS_CRATE,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_SI,        SCENE_SPOT17,                         -28800,                      GI_SKULL_TOKEN,      "GS Crate", "DMC GS Crate"),
    RC_OBJECT(RC_DMC_GREAT_FAIRY_REWARD,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_BG_DY_YOSEIZO,SCENE_DAIYOUSEI_IZUMI,                2,                           GI_NONE,             "Great Fairy Reward", "DMC Great Fairy Reward"),
    RC_OBJECT(RC_SHEIK_IN_CRATER,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Sheik in Crater", "Sheik in Crater"),
    RC_OBJECT(RC_DMC_GOSSIP_STONE,                                            RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_GS,        SCENE_SPOT17,                         14341,                       GI_NONE,             "Gossip Stone", "DMC Gossip Stone"),
    RC_OBJECT(RC_DMC_UPPER_GROTTO_GOSSIP_STONE,                               RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_DEATH_MOUNTAIN_CRATER,  ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -23802,                      GI_NONE,             "Upper Grotto Gossip Stone", "DMC Upper Grotto Gossip Stone"),


    RC_OBJECT(RC_ZR_OPEN_GROTTO_CHEST,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_BOX,       SCENE_KAKUSIANA,                      22985,                       GI_RUPEE_RED,        "Open Grotto Chest", "ZR Open Grotto Chest"),
    RC_OBJECT(RC_ZR_MAGIC_BEAN_SALESMAN,                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_ID_MAX,       SCENE_SPOT03,                         0x00,                        GI_NONE,             "Magic Bean Salesman", "ZR Magic Bean Salesman"),
    RC_OBJECT(RC_ZR_FROGS_ZELDAS_LULLABY,                                     RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs Zelda's Lullaby", "ZR Frogs Zelda's Lullaby"),
    RC_OBJECT(RC_ZR_FROGS_EPONAS_SONG,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs Epona's Song", "ZR Frogs Epona's Song"),
    RC_OBJECT(RC_ZR_FROGS_SARIAS_SONG,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs Saria's Song", "ZR Frogs Saria's Song"),
    RC_OBJECT(RC_ZR_FROGS_SUNS_SONG,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs Sun's Song", "ZR Frogs Sun's Song"),
    RC_OBJECT(RC_ZR_FROGS_SONG_OF_TIME,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs Song of Time", "ZR Frogs Song of Time"),
    RC_OBJECT(RC_ZR_FROGS_IN_THE_RAIN,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs in the Rain", "ZR Frogs in the Rain"),
    RC_OBJECT(RC_ZR_FROGS_OCARINA_GAME,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_FR,        SCENE_SPOT03,                         0x00,                        GI_NONE,             "Frogs Ocarina Game", "ZR Frogs Ocarina Game"),
    RC_OBJECT(RC_ZR_NEAR_OPEN_GROTTO_FREESTANDING_POH,                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_ITEM00,    SCENE_SPOT03,                         1030,                        GI_HEART_PIECE,      "Near Open Grotto Freestanding PoH", "ZR Near Open Grotto Freestanding PoH"),
    RC_OBJECT(RC_ZR_NEAR_DOMAIN_FREESTANDING_POH,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_ITEM00,    SCENE_SPOT03,                         2822,                        GI_HEART_PIECE,      "Near Domain Freestanding PoH", "ZR Near Domain Freestanding PoH"),
    RC_OBJECT(RC_ZR_DEKU_SCRUB_GROTTO_REAR,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x07,0xEB), GI_POTION_RED,       "Deku Scrub Grotto Rear", "ZR Deku Scrub Grotto Rear"),
    RC_OBJECT(RC_ZR_DEKU_SCRUB_GROTTO_FRONT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_RIVER,            ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x08,0xEB), GI_POTION_GREEN,     "Deku Scrub Grotto Front", "ZR Deku Scrub Grotto Front"),
    RC_OBJECT(RC_ZR_GS_LADDER,                                                RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_SPOT03,                         20737,                       GI_SKULL_TOKEN,      "GS Ladder", "ZR GS Ladder"),
    RC_OBJECT(RC_ZR_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_SPOT03,                         -28414,                      GI_SKULL_TOKEN,      "GS Tree", "ZR GS Tree"),
    RC_OBJECT(RC_ZR_GS_ABOVE_BRIDGE,                                          RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_SPOT03,                         20744,                       GI_SKULL_TOKEN,      "GS Above Bridge", "ZR GS Above Bridge"),
    RC_OBJECT(RC_ZR_GS_NEAR_RAISED_GROTTOS,                                   RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_RIVER,            ACTOR_EN_SI,        SCENE_SPOT03,                         20752,                       GI_SKULL_TOKEN,      "GS Near Raised Grottos", "ZR GS Near Raised Grottos"),
    RC_OBJECT(RC_ZR_NEAR_DOMAIN_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_RIVER,            ACTOR_EN_GS,        SCENE_SPOT03,                         14860,                       GI_NONE,             "Near Domain Gossip Stone", "ZR Near Domain Gossip Stone"),
    RC_OBJECT(RC_ZR_NEAR_GROTTOS_GOSSIP_STONE,                                RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_RIVER,            ACTOR_EN_GS,        SCENE_SPOT03,                         14605,                       GI_NONE,             "Near Grottos Gossip Stone", "ZR Near Grottos Gossip Stone"),
    RC_OBJECT(RC_ZR_OPEN_GROTTO_GOSSIP_STONE,                                 RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_RIVER,            ACTOR_EN_GS,        SCENE_KAKUSIANA,                      -22985,                      GI_NONE,             "Open Grotto Gossip Stone", "ZR Open Grotto Gossip Stone"),


    RC_OBJECT(RC_ZD_CHEST,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_EN_BOX,       SCENE_SPOT07,                         -18496,                      GI_HEART_PIECE,      "Chest", "ZD Chest"),
    RC_OBJECT(RC_ZD_DIVING_MINIGAME,                                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_ID_MAX,       SCENE_SPOT07,                         0x00,                        GI_NONE,             "Diving Minigame", "ZD Diving Minigame"),
    RC_OBJECT(RC_ZD_KING_ZORA_THAWED,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_ID_MAX,       SCENE_SPOT07,                         0x00,                        GI_NONE,             "King Zora Thawed", "ZD King Zora Thawed"),
    RC_OBJECT(RC_ZD_TRADE_PRESCRIPTION,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_DOMAIN,           ACTOR_ID_MAX,       SCENE_SPOT07,                         0x00,                        GI_NONE,             "Trade Prescription", "ZD Trade Prescription"),
    RC_OBJECT(RC_ZD_GS_FROZEN_WATERFALL,                                      RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_DOMAIN,           ACTOR_EN_SI,        SCENE_SPOT07,                         20800,                       GI_SKULL_TOKEN,      "GS Frozen Waterfall", "ZD GS Frozen Waterfall"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_1,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x00,                        GI_TUNIC_ZORA,       "Shop Item 1", "ZD Shop Item 1"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_2,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x01,                        GI_ARROWS_SMALL,     "Shop Item 2", "ZD Shop Item 2"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_3,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x02,                        GI_HEART,            "Shop Item 3", "ZD Shop Item 3"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_4,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x03,                        GI_ARROWS_MEDIUM,    "Shop Item 4", "ZD Shop Item 4"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_5,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x04,                        GI_NUTS_5_2,         "Shop Item 5", "ZD Shop Item 5"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_6,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x05,                        GI_ARROWS_LARGE,     "Shop Item 6", "ZD Shop Item 6"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_7,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x06,                        GI_FISH,             "Shop Item 7", "ZD Shop Item 7"),
    RC_OBJECT(RC_ZD_SHOP_ITEM_8,                                              RCVORMQ_BOTH,    RCTYPE_SHOP,         RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GIRLA,     SCENE_ZOORA,                          0x07,                        GI_POTION_RED,       "Shop Item 8", "ZD Shop Item 8"),
    RC_OBJECT(RC_ZD_GOSSIP_STONE,                                             RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_DOMAIN,           ACTOR_EN_GS,        SCENE_SPOT07,                         14345,                       GI_NONE,             "Gossip Stone", "ZD Gossip Stone"),


    RC_OBJECT(RC_ZF_ICEBERC_FREESTANDING_POH,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_ITEM00,    SCENE_SPOT08,                         262,                         GI_HEART_PIECE,      "Iceberg Freestanding PoH", "ZF Iceberg Freestanding PoH"),
    RC_OBJECT(RC_ZF_BOTTOM_FREESTANDING_POH,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_ITEM00,    SCENE_SPOT08,                         5126,                        GI_HEART_PIECE,      "Bottom Freestanding PoH", "ZF Bottom Freestanding PoH"),
    RC_OBJECT(RC_ZF_GS_ABOVE_THE_LOG,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_SI,        SCENE_SPOT08,                         20740,                       GI_SKULL_TOKEN,      "GS Above The Log", "ZF GS Above The Log"),
    RC_OBJECT(RC_ZF_GS_HIDDEN_CAVE,                                           RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_SI,        SCENE_SPOT08,                         20768,                       GI_SKULL_TOKEN,      "GS Hidden Cave", "ZF GS Hidden Cave"),
    RC_OBJECT(RC_ZF_GS_TREE,                                                  RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_SI,        SCENE_SPOT08,                         -28288,                      GI_SKULL_TOKEN,      "GS Tree", "ZF GS Tree"),
    RC_OBJECT(RC_ZF_GREAT_FAIRY_REWARD,                                       RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ZORAS_FOUNTAIN,         ACTOR_BG_DY_YOSEIZO,SCENE_YOUSEI_IZUMI_YOKO,              1,                           GI_NONE,             "Great Fairy Reward", "ZF Great Fairy Reward"),
    RC_OBJECT(RC_FAIRY_GOSSIP_STONE,                                          RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_GS,        SCENE_SPOT08,                         0x00,                        GI_NONE,             "Fairy Gossip Stone", "Fairy Gossip Stone"),
    RC_OBJECT(RC_JABU_GOSSIP_STONE,                                           RCVORMQ_BOTH,    RCTYPE_GOSSIP_STONE, RCAREA_ZORAS_FOUNTAIN,         ACTOR_EN_GS,        SCENE_SPOT08,                         0x00,                        GI_NONE,             "Jabu Gossip Stone", "Jabu Gossip Stone"),


    RC_OBJECT(RC_LLR_TALONS_CHICKENS,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LON_LON_RANCH,          ACTOR_ID_MAX,       SCENE_SOUKO,                          0x00,                        GI_NONE,             "Talons Chickens", "LLR Talons Chickens"),
    RC_OBJECT(RC_LLR_FREESTANDING_POH,                                        RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LON_LON_RANCH,          ACTOR_EN_ITEM00,    SCENE_SOUKO,                          262,                         GI_HEART_PIECE,      "Freestanding PoH", "LLR Freestanding PoH"),
    RC_OBJECT(RC_LLR_DEKU_SCRUB_GROTTO_LEFT,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LON_LON_RANCH,          ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x00,0xFC), GI_NUTS_5_2,         "Deku Scrub Grotto Left", "LLR Deku Scrub Grotto Left"),
    RC_OBJECT(RC_LLR_DEKU_SCRUB_GROTTO_RIGHT,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LON_LON_RANCH,          ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x05,0xFC), GI_BOMBS_5,          "Deku Scrub Grotto Right", "LLR Deku Scrub Grotto Right"),
    RC_OBJECT(RC_LLR_DEKU_SCRUB_GROTTO_CENTER,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LON_LON_RANCH,          ACTOR_EN_DNS,       SCENE_KAKUSIANA,                      TWO_ACTOR_PARAMS(0x03,0xFC), GI_SEEDS_30,         "Deku Scrub Grotto Center", "LLR Deku Scrub Grotto Center"),
    RC_OBJECT(RC_LLR_GS_BACK_WALL,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_SPOT20,                         11009,                       GI_SKULL_TOKEN,      "GS Back Wall", "LLR GS Back Wall"),
    RC_OBJECT(RC_LLR_GS_RAIN_SHED,                                            RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_SPOT20,                         11010,                       GI_SKULL_TOKEN,      "GS Rain Shed", "LLR GS Rain Shed"),
    RC_OBJECT(RC_LLR_GS_HOUSE_WINDOW,                                         RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_SPOT20,                         11012,                       GI_SKULL_TOKEN,      "GS House Window", "LLR GS House Window"),
    RC_OBJECT(RC_LLR_GS_TREE,                                                 RCVORMQ_BOTH,    RCTYPE_SKULL_TOKEN,  RCAREA_LON_LON_RANCH,          ACTOR_EN_SI,        SCENE_SPOT20,                         -29944,                      GI_SKULL_TOKEN,      "GS Tree", "LLR GS Tree"),
    RC_OBJECT(RC_SONG_FROM_MALON,                                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_LON_LON_RANCH,          ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Song from Malon", "Song from Malon"),
    RC_OBJECT(RC_LLR_STABLES_LEFT_COW,                                        RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_MALON_STABLE,                   TWO_ACTOR_PARAMS(-122,-254), GI_MILK,             "Stables Left Cow", "LLR Stables Left Cow"),
    RC_OBJECT(RC_LLR_STABLES_RIGHT_COW,                                       RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_MALON_STABLE,                   TWO_ACTOR_PARAMS(116,-254),  GI_MILK,             "Stables Right Cow", "LLR Stables Right Cow"),
    RC_OBJECT(RC_LLR_TOWER_LEFT_COW,                                          RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_SOUKO,                          TWO_ACTOR_PARAMS(-229,157),  GI_MILK,             "Tower Left Cow", "LLR Tower Left Cow"),
    RC_OBJECT(RC_LLR_TOWER_RIGHT_COW,                                         RCVORMQ_BOTH,    RCTYPE_COW,          RCAREA_LON_LON_RANCH,          ACTOR_EN_COW,       SCENE_SOUKO,                          TWO_ACTOR_PARAMS(-142,-140), GI_MILK,             "Tower Right Cow", "LLR Tower Right Cow"),


    RC_OBJECT(RC_DEKU_TREE_MAP_CHEST,                                         RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           2083,                        GI_MAP,              "Map Chest", "Deku Tree Map Chest"),
    RC_OBJECT(RC_DEKU_TREE_COMPASS_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           2050,                        GI_COMPASS,          "Compass Chest", "Deku Tree Compass Chest"),
    RC_OBJECT(RC_DEKU_TREE_COMPASS_ROOM_SIDE_CHEST,                           RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           22790,                       GI_HEART,            "Compass Room Side Chest", "Deku Tree Compass Room Side Chest"),
    RC_OBJECT(RC_DEKU_TREE_BASEMENT_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           22788,                       GI_HEART,            "Basement Chest", "Deku Tree Basement Chest"),
    RC_OBJECT(RC_DEKU_TREE_SLINGSHOT_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           161,                         GI_SLINGSHOT,        "Slingshot Chest", "Deku Tree Slingshot Chest"),
    RC_OBJECT(RC_DEKU_TREE_SLINGSHOT_ROOM_SIDE_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           22789,                       GI_HEART,            "Slingshot Room Side Chest", "Deku Tree Slingshot Room Side Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_MAP_CHEST,                                      RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           2083,                        GI_MAP,              "MQ Map Chest", "Deku Tree MQ Map Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_COMPASS_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           2049,                        GI_COMPASS,          "MQ Compass Chest", "Deku Tree MQ Compass Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_SLINGSHOT_CHEST,                                RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           4262,                        GI_SLINGSHOT,        "MQ Slingshot Chest", "Deku Tree MQ Slingshot Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_SLINGSHOT_ROOM_BACK_CHEST,                      RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           -31454,                      GI_SHIELD_DEKU,      "MQ Slingshot Room Back Chest", "Deku Tree MQ Slingshot Room Back Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_BASEMENT_CHEST,                                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           -31452,                      GI_SHIELD_DEKU,      "MQ Basement Chest", "Deku Tree MQ Basement Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_BEFORE_SPINNING_LOG_CHEST,                      RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           22789,                       GI_HEART,            "MQ Before Spinning Log Chest", "Deku Tree MQ Before Spinning Log Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_AFTER_SPINNING_LOG_CHEST,                       RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_BOX,       SCENE_YDAN,                           23200,                       GI_RUPEE_PURPLE,     "MQ After Spinning Log Chest", "Deku Tree MQ After Spinning Log Chest"),
    RC_OBJECT(RC_DEKU_TREE_MQ_DEKU_SCRUB,                                     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_EN_DNS,       SCENE_YDAN,                           0x04,                        GI_SHIELD_DEKU,      "MQ Deku Scrub", "Deku Tree MQ Deku Scrub"),
    RC_OBJECT(RC_DEKU_TREE_GS_BASEMENT_BACK_ROOM,                             RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8193,                        GI_SKULL_TOKEN,      "GS Basement Back Room", "Deku Tree GS Basement Back Room"),
    RC_OBJECT(RC_DEKU_TREE_GS_BASEMENT_GATE,                                  RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8194,                        GI_SKULL_TOKEN,      "GS Basement Gate", "Deku Tree GS Basement Gate"),
    RC_OBJECT(RC_DEKU_TREE_GS_BASEMENT_VINES,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8196,                        GI_SKULL_TOKEN,      "GS Basement Vines", "Deku Tree GS Basement Vines"),
    RC_OBJECT(RC_DEKU_TREE_GS_COMPASS_ROOM,                                   RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8200,                        GI_SKULL_TOKEN,      "GS Compass Room", "Deku Tree GS Compass Room"),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_LOBBY,                                       RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8194,                        GI_SKULL_TOKEN,      "MQ GS Lobby", "Deku Tree MQ GS Lobby"),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_COMPASS_ROOM,                                RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8200,                        GI_SKULL_TOKEN,      "MQ GS Compass Room", "Deku Tree MQ GS Compass Room"),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_BASEMENT_GRAVES_ROOM,                        RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8196,                        GI_SKULL_TOKEN,      "MQ GS Basement Graves Room", "Deku Tree MQ GS Basement Graves Room"),
    RC_OBJECT(RC_DEKU_TREE_MQ_GS_BASEMENT_BACK_ROOM,                          RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DEKU_TREE,              ACTOR_EN_SI,        SCENE_YDAN,                           8193,                        GI_SKULL_TOKEN,      "MQ GS Basement Back Room", "Deku Tree MQ GS Basement Back Room"),
    RC_OBJECT(RC_QUEEN_GOHMA,                                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_DOOR_WARP1,   SCENE_YDAN_BOSS,                      0x00,                        GI_NONE,             "Queen Gohma", "Queen Gohma"),
    RC_OBJECT(RC_DEKU_TREE_QUEEN_GOHMA_HEART,                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DEKU_TREE,              ACTOR_ITEM_B_HEART, SCENE_YDAN_BOSS,                      0x00,                        GI_HEART_CONTAINER,  "Queen Gohma Heart Container", "Deku Tree Queen Gohma Heart Container"),


    RC_OBJECT(RC_DODONGOS_CAVERN_BOSS_ROOM_CHEST,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN_BOSS,                      20512,                       GI_BOMBS_5,          "Boss Room Chest", "Dodongos Cavern Boss Room Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MAP_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           2088,                        GI_MAP,              "Map Chest", "Dodongos Cavern Map Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_COMPASS_CHEST,                               RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           2053,                        GI_COMPASS,          "Compass Chest", "Dodongos Cavern Compass Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_BOMB_FLOWER_PLATFORM_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           22982,                       GI_RUPEE_RED,        "Bomb Flower Platform Chest", "Dodongos Cavern Bomb Flower Platform Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_BOMB_BAG_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           1604,                        GI_BOMB_BAG_20,      "Bomb Bag Chest", "Dodongos Cavern Bomb Bag Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_END_OF_BRIDGE_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           21802,                       GI_SHIELD_DEKU,      "End Of Bridge Chest", "Dodongos Cavern End Of Bridge Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_NEAR_BOMB_BAG_LEFT,               RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x00,                        GI_NUTS_5_2,         "Deku Scrub Near Bomb Bag Left", "Dodongos Cavern Deku Scrub Near Bomb Bag Left"),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_SIDE_ROOM_NEAR_DODONGOS,          RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x01,                        GI_STICKS_1,         "Deku Scrub Side Room Near Dodongos", "Dodongos Cavern Deku Scrub Side Room Near Dodongos"),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_NEAR_BOMB_BAG_RIGHT,              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x03,                        GI_SEEDS_30,         "Deku Scrub Near Bomb Bag Right", "Dodongos Cavern Deku Scrub Near Bomb Bag Right"),
    RC_OBJECT(RC_DODONGOS_CAVERN_DEKU_SCRUB_LOBBY,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x04,                        GI_SHIELD_DEKU,      "Deku Scrub Lobby", "Dodongos Cavern Deku Scrub Lobby"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_MAP_CHEST,                                RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           2080,                        GI_MAP,              "MQ Map Chest", "Dodongos Cavern MQ Map Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_BOMB_BAG_CHEST,                           RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           1604,                        GI_BOMB_BAG_20,      "MQ Bomb Bag Chest", "Dodongos Cavern MQ Bomb Bag Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_COMPASS_CHEST,                            RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           6149,                        GI_COMPASS,          "MQ Compass Chest", "Dodongos Cavern MQ Compass Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_LARVAE_ROOM_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           29986,                       GI_SHIELD_DEKU,      "MQ Larvae Room Chest", "Dodongos Cavern MQ Larvae Room Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_TORCH_PUZZLE_ROOM_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           22947,                       GI_RUPEE_BLUE,       "MQ Torch Puzzle Room Chest", "Dodongos Cavern MQ Torch Puzzle Room Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_UNDER_GRAVE_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_BOX,       SCENE_DDAN,                           21825,                       GI_SHIELD_HYLIAN,    "MQ Under Grave Chest", "Dodongos Cavern MQ Under Grave Chest"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_LOBBY_REAR,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x01,                        GI_STICKS_1,         "Deku Scrub Lobby Rear", "Dodongos Cavern Deku Scrub Lobby Rear"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_LOBBY_FRONT,                   RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x03,                        GI_SEEDS_30,         "Deku Scrub Lobby Front", "Dodongos Cavern Deku Scrub Lobby Front"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_STAIRCASE,                     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x04,                        GI_SHIELD_DEKU,      "Deku Scrub Staircase", "Dodongos Cavern Deku Scrub Staircase"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_DEKU_SCRUB_SIDE_ROOM_NEAR_LOWER_LIZALFOS, RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_EN_DNS,       SCENE_DDAN,                           0x07,                        GI_POTION_RED,       "Deku Scrub Side Room Near Lower Lizalfos", "Dodongos Cavern Deku Scrub Side Room Near Lower Lizalfos"),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_VINES_ABOVE_STAIRS,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8449,                        GI_SKULL_TOKEN,      "GS Vines Above Stairs", "Dodongos Cavern GS Vines Above Stairs"),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_SCARECROW,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8450,                        GI_SKULL_TOKEN,      "GS Scarecrow", "Dodongos Cavern GS Scarecrow"),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_ALCOVE_ABOVE_STAIRS,                      RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8452,                        GI_SKULL_TOKEN,      "GS Alcove Above Stairs", "Dodongos Cavern GS Alcove Above Stairs"),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_BACK_ROOM,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8456,                        GI_SKULL_TOKEN,      "GS Back Room", "Dodongos Cavern GS Back Room"),
    RC_OBJECT(RC_DODONGOS_CAVERN_GS_SIDE_ROOM_NEAR_LOWER_LIZALFOS,            RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8464,                        GI_SKULL_TOKEN,      "GS Side Room Near Lower Lizalfos", "Dodongos Cavern GS Side Room Near Lower Lizalfos"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_SCRUB_ROOM,                            RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8450,                        GI_SKULL_TOKEN,      "MQ GS Scrub Room", "Dodongos Cavern MQ GS Scrub Room"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_SONG_OF_TIME_BLOCK_ROOM,               RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8456,                        GI_SKULL_TOKEN,      "MQ GS Song of Time Block Room", "Dodongos Cavern MQ GS Song of Time Block Room"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_LIZALFOS_ROOM,                         RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8452,                        GI_SKULL_TOKEN,      "MQ GS Lizalfos Room", "Dodongos Cavern MQ GS Lizalfos Room"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_LARVAE_ROOM,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8464,                        GI_SKULL_TOKEN,      "MQ GS Larvae Room", "Dodongos Cavern MQ GS Larvae Room"),
    RC_OBJECT(RC_DODONGOS_CAVERN_MQ_GS_BACK_AREA,                             RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_DODONGOS_CAVERN,        ACTOR_EN_SI,        SCENE_DDAN,                           8449,                        GI_SKULL_TOKEN,      "MQ GS Back Room", "Dodongos Cavern MQ GS Back Room"),
    RC_OBJECT(RC_KING_DODONGO,                                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_DOOR_WARP1,   SCENE_DDAN_BOSS,                      0x00,                        GI_NONE,             "King Dodongo", "King Dodongo"),
    RC_OBJECT(RC_DODONGOS_CAVERN_KING_DODONGO_HEART,                          RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_DODONGOS_CAVERN,        ACTOR_ITEM_B_HEART, SCENE_DDAN_BOSS,                      0x00,                        GI_HEART_CONTAINER,  "King Dodongo Heart Container", "Dodongos Cavern King Dodongo Heart Container"),
    RC_OBJECT(RC_DODONGOS_CAVERN_GOSSIP_STONE,                                RCVORMQ_VANILLA, RCTYPE_GOSSIP_STONE, RCAREA_DODONGOS_CAVERN,        ACTOR_EN_GS,        SCENE_DDAN,                           4372,                        GI_NONE,             "Gossip Stone", "Dodongo's Cavern Gossip Stone"),


    RC_OBJECT(RC_JABU_JABUS_BELLY_MAP_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           6178,                        GI_MAP,              "Map Chest", "Jabu Jabus Belly Map Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_COMPASS_CHEST,                              RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -18428,                      GI_COMPASS,          "Compass Chest", "Jabu Jabus Belly Compass Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_BOOMERANG_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           4289,                        GI_BOOMERANG,        "Boomerang Chest", "Jabu Jabus Belly Boomerang Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_DEKU_SCRUB,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_DNS,       SCENE_BDAN,                           0x00,                        GI_NUTS_5_2,         "Deku Scrub", "Jabu Jabus Belly Deku Scrub"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_FIRST_ROOM_SIDE_CHEST,                   RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -32699,                      GI_NUTS_5,           "MQ First Room Side Chest", "Jabu Jabus Belly MQ First Room Side Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_MAP_CHEST,                               RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -18397,                      GI_MAP,              "MQ Map Chest", "Jabu Jabus Belly MQ Map Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_SECOND_ROOM_LOWER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           20546,                       GI_NUTS_5,           "MQ Second Room Lower Chest", "Jabu Jabus Belly MQ Second Room Lower Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_COMPASS_CHEST,                           RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -18432,                      GI_COMPASS,          "MQ Compass Chest", "Jabu Jabus Belly MQ Compass Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_SECOND_ROOM_UPPER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -30457,                      GI_HEART,            "MQ Second Room Upper Chest", "Jabu Jabus Belly MQ Second Room Upper Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BASEMENT_NEAR_SWITCHES_CHEST,            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -32696,                      GI_NUTS_5,           "MQ Basement Near Switches Chest", "Jabu Jabus Belly MQ Basement Near Switches Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BASEMENT_NEAR_VINES_CHEST,               RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -32668,                      GI_BOMBCHUS_10,      "MQ Basement Near Vines Chest", "Jabu Jabus Belly MQ Basement Near Vines Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_NEAR_BOSS_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           -31446,                      GI_SHIELD_DEKU,      "MQ Near Boss Chest", "Jabu Jabus Belly MQ Near Boss Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_FALLING_LIKE_LIKE_ROOM_CHEST,            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           28905,                       GI_STICKS_1,         "MQ Falling Like Like Room Chest", "Jabu Jabus Belly MQ Falling Like Like Room Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BOOMERANG_ROOM_SMALL_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           20545,                       GI_NUTS_5,           "MQ Boomerang Room Small Chest", "Jabu Jabus Belly MQ Boomerang Room Small Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_BOOMERANG_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_BOX,       SCENE_BDAN,                           4294,                        GI_BOOMERANG,        "MQ Boomerang Chest", "Jabu Jabus Belly MQ Boomerang Chest"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_COW,                                     RCVORMQ_MQ,      RCTYPE_COW,          RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_COW,       SCENE_BDAN,                           0x00,                        GI_MILK,             "MQ Cow", "Jabu Jabus Belly MQ Cow"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_LOBBY_BASEMENT_LOWER,                    RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8705,                        GI_SKULL_TOKEN,      "GS Lobby Basement Lower", "Jabu Jabus Belly GS Lobby Basement Lower"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_LOBBY_BASEMENT_UPPER,                    RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8706,                        GI_SKULL_TOKEN,      "GS Lobby Basement Upper", "Jabu Jabus Belly GS Lobby Basement Upper"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_NEAR_BOSS,                               RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8708,                        GI_SKULL_TOKEN,      "GS Near Boss", "Jabu Jabus Belly GS Near Boss"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_GS_WATER_SWITCH_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8712,                        GI_SKULL_TOKEN,      "GS Water Switch Room", "Jabu Jabus Belly GS Water Switch Room"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_TAILPASARAN_ROOM,                     RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8708,                        GI_SKULL_TOKEN,      "MQ GS Tail Parasan Room", "Jabu Jabus Belly MQ GS Tail Parasan Room"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_INVISIBLE_ENEMIES_ROOM,               RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8712,                        GI_SKULL_TOKEN,      "MQ GS Invisible Enemies Room", "Jabu Jabus Belly MQ GS Invisible Enemies Room"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_BOOMERANG_CHEST_ROOM,                 RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8705,                        GI_SKULL_TOKEN,      "MQ GS Boomerang Chest Room", "Jabu Jabus Belly MQ GS Boomerang Chest Room"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_MQ_GS_NEAR_BOSS,                            RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_JABU_JABUS_BELLY,       ACTOR_EN_SI,        SCENE_BDAN,                           8706,                        GI_SKULL_TOKEN,      "MQ GS Near Boss", "Jabu Jabus Belly MQ GS Near Boss"),
    RC_OBJECT(RC_BARINADE,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_DOOR_WARP1,   SCENE_BDAN_BOSS,                      0x00,                        GI_NONE,             "Barinade", "Barinade"),
    RC_OBJECT(RC_JABU_JABUS_BELLY_BARINADE_HEART,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_JABU_JABUS_BELLY,       ACTOR_ITEM_B_HEART, SCENE_BDAN_BOSS,                      0x00,                        GI_HEART_CONTAINER,  "Barinade Heart Container", "Jabu Jabus Belly Barinade Heart Container"),


    RC_OBJECT(RC_FOREST_TEMPLE_FIRST_ROOM_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22595,                       GI_KEY_SMALL,        "First Room Chest", "Forest Temple First Room Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_FIRST_STALFOS_CHEST,                           RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         30784,                       GI_KEY_SMALL,        "First Stalfos Chest", "Forest Temple First Stalfos Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_RAISED_ISLAND_COURTYARD_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22789,                       GI_HEART,            "Raised Island Courtyard Chest", "Forest Temple Raised Island Courtyard Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MAP_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         6177,                        GI_MAP,              "Map Chest", "Forest Temple Map Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_WELL_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22601,                       GI_KEY_SMALL,        "Well Chest", "Forest Temple Well Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_FALLING_CEILING_ROOM_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22855,                       GI_ARROWS_MEDIUM,    "Falling Ceiling Room Chest", "Forest Temple Falling Ceiling Room Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_EYE_SWITCH_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         -30364,                      GI_ARROWS_LARGE,     "Eye Switch Chest", "Forest Temple Eye Switch Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_BOSS_KEY_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         10222,                       GI_KEY_BOSS,         "Boss Key Chest", "Forest Temple Boss Key Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_FLOORMASTER_CHEST,                             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         30786,                       GI_KEY_SMALL,        "Floormaster Chest", "Forest Temple Floormaster Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_BOW_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         -20340,                      GI_BOW,              "Bow Chest", "Forest Temple Bow Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_RED_POE_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         30797,                       GI_KEY_SMALL,        "Red Poe Chest", "Forest Temple Red Poe Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_BLUE_POE_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         6159,                        GI_COMPASS,          "Blue Poe Chest", "Forest Temple Blue Poe Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_BASEMENT_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22827,                       GI_ARROWS_SMALL,     "Basement Chest", "Forest Temple Basement Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_FIRST_ROOM_CHEST,                           RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         -30653,                      GI_KEY_SMALL,        "MQ First Room Chest", "Forest Temple MQ First Room Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_WOLFOS_CHEST,                               RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         30784,                       GI_KEY_SMALL,        "MQ Wolfos Chest", "Forest Temple MQ Wolfos Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_BOW_CHEST,                                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         -20340,                      GI_BOW,              "MQ Bow Chest", "Forest Temple MQ Bow Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_RAISED_ISLAND_COURTYARD_LOWER_CHEST,        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22593,                       GI_KEY_SMALL,        "MQ Raised Island Courtyard Lower Chest", "Forest Temple MQ Raised Island Courtyard Lower Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_RAISED_ISLAND_COURTYARD_UPPER_CHEST,        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22597,                       GI_KEY_SMALL,        "MQ Raised Island Courtyard Upper Chest", "Forest Temple MQ Raised Island Courtyard Upper Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_WELL_CHEST,                                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22601,                       GI_KEY_SMALL,        "MQ Well Chest", "Forest Temple MQ Well Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_MAP_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         6189,                        GI_MAP,              "MQ Map Chest", "Forest Temple MQ Map Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_COMPASS_CHEST,                              RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         6159,                        GI_COMPASS,          "MQ Compass Chest", "Forest Temple MQ Compass Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_FALLING_CEILING_ROOM_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         -30426,                      GI_ARROWS_SMALL,     "MQ Falling Ceiling Room Chest", "Forest Temple MQ Falling Ceiling Room Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_BASEMENT_CHEST,                             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         22827,                       GI_ARROWS_SMALL,     "MQ Basement Chest", "Forest Temple MQ Basement Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_REDEAD_CHEST,                               RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         30786,                       GI_KEY_SMALL,        "MQ Redead Chest", "Forest Temple MQ Redead Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_BOSS_KEY_CHEST,                             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_EN_BOX,       SCENE_BMORI1,                         10222,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Forest Temple MQ Boss Key Chest"),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_RAISED_ISLAND_COURTYARD,                    RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8961,                        GI_SKULL_TOKEN,      "GS Raised Island Courtyard", "Forest Temple GS Raised Island Courtyard"),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_FIRST_ROOM,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8962,                        GI_SKULL_TOKEN,      "GS First Room", "Forest Temple GS First Room"),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_LEVEL_ISLAND_COURTYARD,                     RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8964,                        GI_SKULL_TOKEN,      "GS Level Island Courtyard", "Forest Temple GS Level Island Courtyard"),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_LOBBY,                                      RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8968,                        GI_SKULL_TOKEN,      "GS Lobby", "Forest Temple GS Lobby"),
    RC_OBJECT(RC_FOREST_TEMPLE_GS_BASEMENT,                                   RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8976,                        GI_SKULL_TOKEN,      "GS Basement", "Forest Temple GS Basement"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_FIRST_HALLWAY,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8962,                        GI_SKULL_TOKEN,      "MQ GS First Hallway", "Forest Temple MQ GS First Hallway"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_BLOCK_PUSH_ROOM,                         RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8976,                        GI_SKULL_TOKEN,      "MQ GS Block Push Room", "Forest Temple MQ GS Block Push Room"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_RAISED_ISLAND_COURTYARD,                 RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8961,                        GI_SKULL_TOKEN,      "MQ GS Raised Island Courtyard", "Forest Temple MQ GS Raised Island Courtyard"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_LEVEL_ISLAND_COURTYARD,                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8964,                        GI_SKULL_TOKEN,      "MQ GS Level Island Courtyard", "Forest Temple MQ GS Level Island Courtyard"),
    RC_OBJECT(RC_FOREST_TEMPLE_MQ_GS_WELL,                                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FOREST_TEMPLE,          ACTOR_EN_SI,        SCENE_BMORI1,                         8968,                        GI_SKULL_TOKEN,      "MQ GS Well", "Forest Temple MQ GS Well"),
    RC_OBJECT(RC_PHANTOM_GANON,                                               RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_DOOR_WARP1,   SCENE_MORIBOSSROOM,                   0x00,                        GI_NONE,             "Phantom Ganon", "Phantom Ganon"),
    RC_OBJECT(RC_FOREST_TEMPLE_PHANTOM_GANON_HEART,                           RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_FOREST_TEMPLE,          ACTOR_ITEM_B_HEART, SCENE_MORIBOSSROOM,                   0x00,                        GI_HEART_CONTAINER,  "Phantom Ganon Heart Container", "Forest Temple Phantom Ganon Heart Container"),


    RC_OBJECT(RC_FIRE_TEMPLE_NEAR_BOSS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22593,                       GI_KEY_SMALL,        "Near Boss Chest", "Fire Temple Near Boss Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_FLARE_DANCER_CHEST,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          31936,                       GI_BOMBS_10,         "Flare Dancer Chest", "Fire Temple Flare Dancer Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BOSS_KEY_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          10220,                       GI_KEY_BOSS,         "Boss Key Chest", "Fire Temple Boss Key Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BIG_LAVA_ROOM_BLOCKED_DOOR_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22594,                       GI_KEY_SMALL,        "Big Lava Room Blocked Door Chest", "Fire Temple Big Lava Room Blocked Door Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BIG_LAVA_ROOM_LOWER_OPEN_DOOR_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22596,                       GI_KEY_SMALL,        "Big Lava Room Lower Open Door Chest", "Fire Temple Big Lava Room Lower Open Door Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_LOWER_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22595,                       GI_KEY_SMALL,        "Boulder Maze Lower Chest", "Fire Temple Boulder Maze Lower Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_UPPER_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22598,                       GI_KEY_SMALL,        "Boulder Maze Upper Chest", "Fire Temple Boulder Maze Upper Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_SIDE_ROOM_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22600,                       GI_KEY_SMALL,        "Boulder Maze Side Room Chest", "Fire Temple Boulder Maze Side Room Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_BOULDER_MAZE_SHORTCUT_CHEST,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22603,                       GI_KEY_SMALL,        "Boulder Maze Shortcut Chest", "Fire Temple Boulder Maze Shortcut Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_SCARECROW_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          23245,                       GI_RUPEE_GOLD,       "Scarecrow Chest", "Fire Temple Scarecrow Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MAP_CHEST,                                       RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          2090,                        GI_MAP,              "Map Chest", "Fire Temple Map Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_COMPASS_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          2055,                        GI_COMPASS,          "Compass Chest", "Fire Temple Compass Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_HIGHEST_GORON_CHEST,                             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22601,                       GI_KEY_SMALL,        "Highest Goron Chest", "Fire Temple Highest Goron Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MEGATON_HAMMER_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          421,                         GI_HAMMER,           "Megaton Hammer Chest", "Fire Temple Megaton Hammer Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_NEAR_BOSS_CHEST,                              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22599,                       GI_KEY_SMALL,        "MQ Near Boss Chest", "Fire Temple MQ Near Boss Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_MEGATON_HAMMER_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          4512,                        GI_HAMMER,           "MQ Megaton Hammer Chest", "Fire Temple MQ Megaton Hammer Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_COMPASS_CHEST,                                RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          2059,                        GI_COMPASS,          "MQ Compass Chest", "Fire Temple MQ Compass Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_LIZALFOS_MAZE_LOWER_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          23747,                       GI_BOMBS_10,         "MQ Lizalfos Maze Lower Chest", "Fire Temple MQ Lizalfos Maze Lower Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_LIZALFOS_MAZE_UPPER_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          23782,                       GI_BOMBS_20,         "MQ Lizalfos Maze Upper Chest", "Fire Temple MQ Lizalfos Maze Upper Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_CHEST_ON_FIRE,                                RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22597,                       GI_KEY_SMALL,        "MQ Chest on Fire", "Fire Temple MQ Chest on Fire"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_MAP_ROOM_SIDE_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          30018,                       GI_SHIELD_HYLIAN,    "MQ Map Room Side Chest", "Fire Temple MQ Map Room Side Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_MAP_CHEST,                                    RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          2092,                        GI_MAP,              "MQ Map Chest", "Fire Temple MQ Map Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_BOSS_KEY_CHEST,                               RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          10212,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Fire Temple MQ Boss Key Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_BIG_LAVA_ROOM_BLOCKED_DOOR_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22593,                       GI_KEY_SMALL,        "MQ Big Lava Room Blocked Door Chest", "Fire Temple MQ Big Lava Room Blocked Door Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_LIZALFOS_MAZE_SIDE_ROOM_CHEST,                RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_BOX,       SCENE_HIDAN,                          22600,                       GI_KEY_SMALL,        "MQ Lizalfos Maze Side Room Chest", "Fire Temple MQ Lizalfos Maze Side Room Chest"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_FREESTANDING_KEY,                             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_EN_ITEM00,    SCENE_HIDAN,                          7185,                        GI_KEY_SMALL,        "MQ Freestanding Key", "Fire Temple MQ Freestanding Key"),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_SONG_OF_TIME_ROOM,                            RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9217,                        GI_SKULL_TOKEN,      "GS Song of Time Room", "Fire Temple GS Song of Time Room"),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_BOSS_KEY_LOOP,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9218,                        GI_SKULL_TOKEN,      "GS Boss Key Loop", "Fire Temple GS Boss Key Loop"),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_BOULDER_MAZE,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9220,                        GI_SKULL_TOKEN,      "GS Boulder Maze", "Fire Temple GS Boulder Maze"),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_SCARECROW_TOP,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9224,                        GI_SKULL_TOKEN,      "GS Scarecrow Top", "Fire Temple GS Scarecrow Top"),
    RC_OBJECT(RC_FIRE_TEMPLE_GS_SCARECROW_CLIMB,                              RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9232,                        GI_SKULL_TOKEN,      "GS Scarecrow Climb", "Fire Temple GS Scarecrow Climb"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_ABOVE_FIRE_WALL_MAZE,                      RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9218,                        GI_SKULL_TOKEN,      "MQ GS Above Fire Wall Maze", "Fire Temple MQ GS Above Fire Wall Maze"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_FIRE_WALL_MAZE_CENTER,                     RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9224,                        GI_SKULL_TOKEN,      "MQ GS Fire Wall Maze Center", "Fire Temple MQ GS Fire Wall Maze Center"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_BIG_LAVA_ROOM_OPEN_DOOR,                   RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9217,                        GI_SKULL_TOKEN,      "MQ GS Big Lava Room Open Door", "Fire Temple MQ GS Big Lava Room Open Door"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_FIRE_WALL_MAZE_SIDE_ROOM,                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9232,                        GI_SKULL_TOKEN,      "MQ GS Fire Wall Maze Side Room", "Fire Temple MQ GS Fire Wall Maze Side Room"),
    RC_OBJECT(RC_FIRE_TEMPLE_MQ_GS_SKULL_ON_FIRE,                             RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_FIRE_TEMPLE,            ACTOR_EN_SI,        SCENE_HIDAN,                          9220,                        GI_SKULL_TOKEN,      "MQ GS Skull on Fire", "Fire Temple MQ GS Skull on Fire"),
    RC_OBJECT(RC_VOLVAGIA,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_DOOR_WARP1,   SCENE_FIRE_BS,                        0x00,                        GI_NONE,             "Volvagia", "Volvagia"),
    RC_OBJECT(RC_FIRE_TEMPLE_VOLVAGIA_HEART,                                  RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_FIRE_TEMPLE,            ACTOR_ITEM_B_HEART, SCENE_FIRE_BS,                        0x00,                        GI_HEART_CONTAINER,  "Volvagia Heart Container", "Fire Temple Volvagia Heart Container"),


    RC_OBJECT(RC_WATER_TEMPLE_MAP_CHEST,                                      RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        6178,                        GI_MAP,              "Map Chest", "Water Temple Map Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_COMPASS_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        2057,                        GI_COMPASS,          "Compass Chest", "Water Temple Compass Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_TORCHES_CHEST,                                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        30785,                       GI_KEY_SMALL,        "Torches Chest", "Water Temple Torches Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_DRAGON_CHEST,                                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        22602,                       GI_KEY_SMALL,        "Dragon Chest", "Water Temple Dragon Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_CENTRAL_BOW_TARGET_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        22600,                       GI_KEY_SMALL,        "Central Bow Target Chest", "Water Temple Central Bow Target Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_CENTRAL_PILLAR_CHEST,                           RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        22598,                       GI_KEY_SMALL,        "Central Pillar Chest", "Water Temple Central Pillar Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_CRACKED_WALL_CHEST,                             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        22592,                       GI_KEY_SMALL,        "Cracked Wall Chest", "Water Temple Cracked Wall Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_BOSS_KEY_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        10213,                       GI_KEY_BOSS,         "Boss Key Chest", "Water Temple Boss Key Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_LONGSHOT_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        295,                         GI_LONGSHOT,         "Longshot Chest", "Water Temple Longshot Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_RIVER_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        22595,                       GI_KEY_SMALL,        "River Chest", "Water Temple River Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_CENTRAL_PILLAR_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        -30650,                      GI_KEY_SMALL,        "MQ Central Pillar Chest", "Water Temple MQ Central Pillar Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_BOSS_KEY_CHEST,                              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        10213,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Water Temple MQ Boss Key Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_LONGSHOT_CHEST,                              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        -20192,                      GI_LONGSHOT,         "MQ Longshot Chest", "Water Temple MQ Longshot Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_COMPASS_CHEST,                               RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        6145,                        GI_COMPASS,          "MQ Compass Chest", "Water Temple MQ Compass Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_MAP_CHEST,                                   RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_WATER_TEMPLE,           ACTOR_EN_BOX,       SCENE_MIZUSIN,                        -18398,                      GI_MAP,              "MQ Map Chest", "Water Temple MQ Map Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_FREESTANDING_KEY,                            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_EN_ITEM00,    SCENE_MIZUSIN,                        273,                         GI_KEY_SMALL,        "MQ Freestanding Key", "Water Temple MQ Freestanding Key"),
    RC_OBJECT(RC_WATER_TEMPLE_GS_BEHIND_GATE,                                 RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9473,                        GI_SKULL_TOKEN,      "GS Behind Gate", "Water Temple GS Behind Gate"),
    RC_OBJECT(RC_WATER_TEMPLE_GS_FALLING_PLATFORM_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9474,                        GI_SKULL_TOKEN,      "GS Falling Platform Room", "Water Temple GS Falling Platform Room"),
    RC_OBJECT(RC_WATER_TEMPLE_GS_CENTRAL_PILLAR,                              RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9476,                        GI_SKULL_TOKEN,      "GS Central Pillar", "Water Temple GS Central Pillar"),
    RC_OBJECT(RC_WATER_TEMPLE_GS_NEAR_BOSS_KEY_CHEST,                         RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9480,                        GI_SKULL_TOKEN,      "GS Near Boss Key Chest", "Water Temple GS Near Boss Key Chest"),
    RC_OBJECT(RC_WATER_TEMPLE_GS_RIVER,                                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9488,                        GI_SKULL_TOKEN,      "GS River", "Water Temple GS River"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_BEFORE_UPPER_WATER_SWITCH,                RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9476,                        GI_SKULL_TOKEN,      "MQ GS Before Upper Water Switch", "Water Temple MQ GS Before Upper Water Switch"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_FREESTANDING_KEY_AREA,                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9480,                        GI_SKULL_TOKEN,      "MQ GS Freestanding Key Area", "Water Temple MQ GS Freestanding Key Area"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_LIZALFOS_HALLWAY,                         RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9473,                        GI_SKULL_TOKEN,      "MQ GS Lizalfos Hallway", "Water Temple MQ GS Lizalfos Hallway"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_RIVER,                                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9474,                        GI_SKULL_TOKEN,      "MQ GS River", "Water Temple MQ GS River"),
    RC_OBJECT(RC_WATER_TEMPLE_MQ_GS_TRIPLE_WALL_TORCH,                        RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_WATER_TEMPLE,           ACTOR_EN_SI,        SCENE_MIZUSIN,                        9488,                        GI_SKULL_TOKEN,      "MQ GS Triple Wall Torch", "Water Temple MQ GS Triple Wall Torch"),
    RC_OBJECT(RC_MORPHA,                                                      RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_DOOR_WARP1,   SCENE_MIZUSIN_BS,                     0x00,                        GI_NONE,             "Morpha", "Morpha"),
    RC_OBJECT(RC_WATER_TEMPLE_MORPHA_HEART,                                   RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_WATER_TEMPLE,           ACTOR_ITEM_B_HEART, SCENE_MIZUSIN_BS,                     0x00,                        GI_HEART_CONTAINER,  "Morpha Heart Container", "Water Temple Morpha Heart Container"),


    RC_OBJECT(RC_SPIRIT_TEMPLE_SILVER_GAUNTLETS_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPOT11,                         1707,                        GI_GAUNTLETS_SILVER, "Silver Gauntlets Chest", "Spirit Temple Silver Gauntlets Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MIRROR_SHIELD_CHEST,                           RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_SPOT11,                         13673,                       GI_SHIELD_MIRROR,    "Mirror Shield Chest", "Spirit Temple Mirror Shield Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_BRIDGE_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      21800,                       GI_SHIELD_DEKU,      "Child Bridge Chest", "Spirit Temple Child Bridge Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_EARLY_TORCHES_CHEST,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30656,                      GI_KEY_SMALL,        "Child Early Torches Chest", "Spirit Temple Child Early Torches Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_COMPASS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      14340,                       GI_COMPASS,          "Compass Chest", "Spirit Temple Compass Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_EARLY_ADULT_RIGHT_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      22599,                       GI_KEY_SMALL,        "Early Adult Right Chest", "Spirit Temple Early Adult Right Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_FIRST_MIRROR_LEFT_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30451,                      GI_HEART,            "First Mirror Left Chest", "Spirit Temple First Mirror Left Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_FIRST_MIRROR_RIGHT_CHEST,                      RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -28786,                      GI_ICE_TRAP,         "First Mirror Right Chest", "Spirit Temple First Mirror Right Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MAP_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -18397,                      GI_MAP,              "Map Chest", "Spirit Temple Map Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_CLIMB_NORTH_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -32666,                      GI_BOMBCHUS_10,      "Child Climb North Chest", "Spirit Temple Child Climb North Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_CHILD_CLIMB_EAST_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -31444,                      GI_SHIELD_DEKU,      "Child Climb East Chest", "Spirit Temple Child Climb East Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_SUN_BLOCK_ROOM_CHEST,                          RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30655,                      GI_KEY_SMALL,        "Sun Block Room Chest", "Spirit Temple Sun Block Room Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_STATUE_ROOM_HAND_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30654,                      GI_KEY_SMALL,        "Statue Room Hand Chest", "Spirit Temple Statue Room Hand Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_STATUE_ROOM_NORTHEAST_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30577,                      GI_MAGIC_LARGE,      "Statue Room Northeast Chest", "Spirit Temple Statue Room Northeast Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_NEAR_FOUR_ARMOS_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      22597,                       GI_KEY_SMALL,        "Near Four Armos Chest", "Spirit Temple Near Four Armos Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_HALLWAY_RIGHT_INVISIBLE_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      26900,                       GI_HEART,            "Hallway Right Invisible Chest", "Spirit Temple Hallway Right Invisible Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_HALLWAY_LEFT_INVISIBLE_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      26901,                       GI_HEART,            "Hallway Left Invisible Chest", "Spirit Temple Hallway Left Invisible Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_BOSS_KEY_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      10218,                       GI_KEY_BOSS,         "Boss Key Chest", "Spirit Temple Boss Key Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_TOPMOST_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -29454,                      GI_BOMBS_20,         "Topmost Chest", "Spirit Temple Topmost Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_FRONT_LEFT_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      20602,                       GI_BOMBCHUS_10,      "MQ Entrance Front Left Chest", "Spirit Temple MQ Entrance Front Left Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_BACK_RIGHT_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -32641,                      GI_BOMBCHUS_10,      "MQ Entrance Back Right Chest", "Spirit Temple MQ Entrance Back Right Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_FRONT_RIGHT_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30629,                      GI_KEY_SMALL,        "MQ Entrance Front Right Chest", "Spirit Temple MQ Entrance Front Right Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_ENTRANCE_BACK_LEFT_CHEST,                   RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30626,                      GI_KEY_SMALL,        "MQ Entrance Back Left Chest", "Spirit Temple MQ Entrance Back Left Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHILD_HAMMER_SWITCH_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30627,                      GI_KEY_SMALL,        "MQ Child Hammer Switch Chest", "Spirit Temple MQ Child Hammer Switch Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_MAP_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      2080,                        GI_MAP,              "MQ Map Chest", "Spirit Temple MQ Map Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_MAP_ROOM_ENEMY_CHEST,                       RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      30792,                       GI_KEY_SMALL,        "MQ Map Room Enemy Chest", "Spirit Temple MQ Map Room Enemy Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHILD_CLIMB_NORTH_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      28774,                       GI_BOMBCHUS_10,      "MQ Child Climb North Chest", "Spirit Temple MQ Child Climb North Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHILD_CLIMB_SOUTH_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30644,                      GI_KEY_SMALL,        "MQ Child Climb South Chest", "Spirit Temple MQ Child Climb South Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_COMPASS_CHEST,                              RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -18429,                      GI_COMPASS,          "MQ Compass Chest", "Spirit Temple MQ Compass Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_STATUE_ROOM_LULLABY_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30577,                      GI_MAGIC_LARGE,      "MQ Statue Room Lullaby Chest", "Spirit Temple MQ Statue Room Lullaby Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_STATUE_ROOM_INVISIBLE_CHEST,                RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      26882,                       GI_HEART,            "MQ Statue Room Invisible Chest", "Spirit Temple MQ Statue Room Invisible Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_SILVER_BLOCK_HALLWAY_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30628,                      GI_KEY_SMALL,        "MQ Silver Block Hallway Chest", "Spirit Temple MQ Silver Block Hallway Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_SUN_BLOCK_ROOM_CHEST,                       RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      -30463,                      GI_HEART,            "MQ Sun Block Room Chest", "Spirit Temple MQ Sun Block Room Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_SYMPHONY_ROOM_CHEST,                        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      23207,                       GI_RUPEE_PURPLE,     "MQ Symphony Room Chest", "Spirit Temple MQ Symphony Room Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_LEEVER_ROOM_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      31396,                       GI_RUPEE_PURPLE,     "MQ Leever Room Chest", "Spirit Temple MQ Leever Room Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_BEAMOS_ROOM_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      24472,                       GI_ICE_TRAP,         "MQ Beamos Room Chest", "Spirit Temple MQ Beamos Room Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_CHEST_SWITCH_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      31097,                       GI_ARROWS_LARGE,     "MQ Chest Switch Chest", "Spirit Temple MQ Chest Switch Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_BOSS_KEY_CHEST,                             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      10213,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Spirit Temple MQ Boss Key Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_MIRROR_PUZZLE_INVISIBLE_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_BOX,       SCENE_JYASINZOU,                      26706,                       GI_KEY_SMALL,        "MQ Mirror Puzzle Invisible Chest", "Spirit Temple MQ Mirror Puzzle Invisible Chest"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_HALL_AFTER_SUN_BLOCK_ROOM,                  RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9729,                        GI_SKULL_TOKEN,      "GS Hall After Sun Block Room", "Spirit Temple GS Hall After Sun Block Room"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_BOULDER_ROOM,                               RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9730,                        GI_SKULL_TOKEN,      "GS Boulder Room", "Spirit Temple GS Boulder Room"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_LOBBY,                                      RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9732,                        GI_SKULL_TOKEN,      "GS Lobby", "Spirit Temple GS Lobby"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_SUN_ON_FLOOR_ROOM,                          RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9736,                        GI_SKULL_TOKEN,      "GS Sun on Floor Room", "Spirit Temple GS Sun on Floor Room"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_GS_METAL_FENCE,                                RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9744,                        GI_SKULL_TOKEN,      "GS Metal Fence", "Spirit Temple GS Metal Fence"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_SYMPHONY_ROOM,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9736,                        GI_SKULL_TOKEN,      "MQ GS Symphony Room", "Spirit Temple MQ GS Symphony Room"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_LEEVER_ROOM,                             RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9730,                        GI_SKULL_TOKEN,      "MQ GS Leever Room", "Spirit Temple MQ GS Leever Room"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_NINE_THRONES_ROOM_WEST,                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9732,                        GI_SKULL_TOKEN,      "MQ GS Nine Thrones Room West", "Spirit Temple MQ GS Nine Thrones Room West"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_NINE_THRONES_ROOM_NORTH,                 RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9744,                        GI_SKULL_TOKEN,      "MQ GS Nine Thrones Room North", "Spirit Temple MQ GS Nine Thrones Room North"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_MQ_GS_SUN_BLOCK_ROOM,                          RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SPIRIT_TEMPLE,          ACTOR_EN_SI,        SCENE_JYASINZOU,                      9729,                        GI_SKULL_TOKEN,      "MQ GS Sun Block Room", "Spirit Temple MQ GS Sun Block Room"),
    RC_OBJECT(RC_TWINROVA,                                                    RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_DOOR_WARP1,   SCENE_JYASINBOSS,                     0x00,                        GI_NONE,             "Twinrova", "Twinrova"),
    RC_OBJECT(RC_SPIRIT_TEMPLE_TWINROVA_HEART,                                RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SPIRIT_TEMPLE,          ACTOR_ITEM_B_HEART, SCENE_JYASINBOSS,                     0x00,                        GI_HEART_CONTAINER,  "Twinrova Heart Container", "Spirit Temple Twinrova Heart Container"),


    RC_OBJECT(RC_SHADOW_TEMPLE_MAP_CHEST,                                     RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        6177,                        GI_MAP,              "Map Chest", "Shadow Temple Map Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_HOVER_BOOTS_CHEST,                             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        5607,                        GI_BOOTS_HOVER,      "Hover Boots Chest", "Shadow Temple Hover Boots Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_COMPASS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        6147,                        GI_COMPASS,          "Compass Chest", "Shadow Temple Compass Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_EARLY_SILVER_RUPEE_CHEST,                      RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22594,                       GI_KEY_SMALL,        "Early Silver Rupee Chest", "Shadow Temple Early Silver Rupee Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_BLADES_VISIBLE_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22668,                       GI_MAGIC_LARGE,      "Invisible Blades Visible Chest", "Shadow Temple Invisible Blades Visible Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_BLADES_INVISIBLE_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26998,                       GI_ARROWS_LARGE,     "Invisible Blades Invisible Chest", "Shadow Temple Invisible Blades Invisible Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_FALLING_SPIKES_LOWER_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22853,                       GI_ARROWS_MEDIUM,    "Falling Spikes Lower Chest", "Shadow Temple Falling Spikes Lower Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_FALLING_SPIKES_UPPER_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22662,                       GI_MAGIC_LARGE,      "Falling Spikes Upper Chest", "Shadow Temple Falling Spikes Upper Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_FALLING_SPIKES_SWITCH_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        -30652,                      GI_KEY_SMALL,        "Falling Spikes Switch Chest", "Shadow Temple Falling Spikes Switch Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_SPIKES_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        30857,                       GI_MAGIC_LARGE,      "Invisible Spikes Chest", "Shadow Temple Invisible Spikes Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_WIND_HINT_CHEST,                               RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26965,                       GI_ARROWS_MEDIUM,    "Wind Hint Chest", "Shadow Temple Wind Hint Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_AFTER_WIND_ENEMY_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        30856,                       GI_MAGIC_LARGE,      "After Wind Enemy Chest", "Shadow Temple After Wind Enemy Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_AFTER_WIND_HIDDEN_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26708,                       GI_KEY_SMALL,        "After Wind Hidden Chest", "Shadow Temple After Wind Hidden Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_SPIKE_WALLS_LEFT_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22666,                       GI_MAGIC_LARGE,      "Spike Walls Left Chest", "Shadow Temple Spike Walls Left Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_BOSS_KEY_CHEST,                                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        10219,                       GI_KEY_BOSS,         "Boss Key Chest", "Shadow Temple Boss Key Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_INVISIBLE_FLOORMASTER_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        30797,                       GI_KEY_SMALL,        "Invisible Floormaster Chest", "Shadow Temple Invisible Floormaster Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_FREESTANDING_KEY,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_ITEM00,    SCENE_HAKADAN,                        273,                         GI_KEY_SMALL,        "Freestanding Key", "Shadow Temple Freestanding Key"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_COMPASS_CHEST,                              RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        6145,                        GI_COMPASS,          "MQ Compass Chest", "Shadow Temple MQ Compass Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_HOVER_BOOTS_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        5607,                        GI_BOOTS_HOVER,      "MQ Hover Boots Chest", "Shadow Temple MQ Hover Boots Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_EARLY_GIBDOS_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        30787,                       GI_KEY_SMALL,        "MQ Early Gibdos Chest", "Shadow Temple MQ Early Gibdos Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_MAP_CHEST,                                  RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        2082,                        GI_MAP,              "MQ Map Chest", "Shadow Temple MQ Map Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_BEAMOS_SILVER_RUPEES_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        -30417,                      GI_ARROWS_SMALL,     "MQ Beamos Silver Rupees Chest", "Shadow Temple MQ Beamos Silver Rupees Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FALLING_SPIKES_SWITCH_CHEST,                RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22662,                       GI_MAGIC_LARGE,      "MQ Falling Spikes Switch Chest", "Shadow Temple MQ Falling Spikes Switch Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FALLING_SPIKES_LOWER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22853,                       GI_ARROWS_MEDIUM,    "MQ Falling Spikes Lower Chest", "Shadow Temple MQ Falling Spikes Lower Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FALLING_SPIKES_UPPER_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        -30652,                      GI_KEY_SMALL,        "MQ Falling Spikes Upper Chest", "Shadow Temple MQ Falling Spikes Upper Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_INVISIBLE_SPIKES_CHEST,                     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        30857,                       GI_MAGIC_LARGE,      "MQ Invisible Spikes Chest", "Shadow Temple MQ Invisible Spikes Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_BOSS_KEY_CHEST,                             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        10219,                       GI_KEY_BOSS,         "MQ Boss Key Chest", "Shadow Temple MQ Boss Key Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_SPIKE_WALLS_LEFT_CHEST,                     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22666,                       GI_KEY_SMALL,        "MQ Spike Walls Left Chest", "Shadow Temple MQ Spike Walls Left Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_STALFOS_ROOM_CHEST,                         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        31184,                       GI_RUPEE_RED,        "MQ Stalfos Room Chest", "Shadow Temple MQ Stalfos Room Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_INVISIBLE_BLADES_INVISIBLE_CHEST,           RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26710,                       GI_KEY_SMALL,        "MQ Invisible Blades Invisible Chest", "Shadow Temple MQ Invisible Blades Invisible Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_INVISIBLE_BLADES_VISIBLE_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        22668,                       GI_MAGIC_LARGE,      "MQ Invisible Blades Visible Chest", "Shadow Temple MQ Invisible Blades Visible Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_BOMB_FLOWER_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        31053,                       GI_ARROWS_MEDIUM,    "MQ Bomb Flower Chest", "Shadow Temple MQ Bomb Flower Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_WIND_HINT_CHEST,                            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26709,                       GI_KEY_SMALL,        "MQ Wind Hint Chest", "Shadow Temple MQ Wind Hint Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_AFTER_WIND_HIDDEN_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26932,                       GI_ARROWS_SMALL,     "MQ After Wind Hidden Chest", "Shadow Temple MQ After Wind Hidden Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_AFTER_WIND_ENEMY_CHEST,                     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        30856,                       GI_MAGIC_LARGE,      "MQ After Wind Enemy Chest", "Shadow Temple MQ After Wind Enemy Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_NEAR_SHIP_INVISIBLE_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_BOX,       SCENE_HAKADAN,                        26702,                       GI_KEY_SMALL,        "MQ Near Ship Invisible Chest", "Shadow Temple MQ Near Ship Invisible Chest"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_FREESTANDING_KEY,                           RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_EN_ITEM00,    SCENE_HAKADAN,                        1553,                        GI_KEY_SMALL,        "MQ Freestanding Key", "Shadow Temple MQ Freestanding Key"),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_SINGLE_GIANT_POT,                           RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9985,                        GI_SKULL_TOKEN,      "GS Single Giant Pot", "Shadow Temple GS Single Giant Pot"),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_FALLING_SPIKES_ROOM,                        RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9986,                        GI_SKULL_TOKEN,      "GS Falling Spikes Room", "Shadow Temple GS Falling Spikes Room"),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_TRIPLE_GIANT_POT,                           RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9988,                        GI_SKULL_TOKEN,      "GS Triple Giant Pot", "Shadow Temple GS Triple Giant Pot"),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_LIKE_LIKE_ROOM,                             RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9992,                        GI_SKULL_TOKEN,      "GS Like Like Room", "Shadow Temple GS Like Like Room"),
    RC_OBJECT(RC_SHADOW_TEMPLE_GS_NEAR_SHIP,                                  RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        10000,                       GI_SKULL_TOKEN,      "GS Near Ship", "Shadow Temple GS Near Ship"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_FALLING_SPIKES_ROOM,                     RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9986,                        GI_SKULL_TOKEN,      "MQ GS Falling Spikes Room", "Shadow Temple MQ GS Falling Spikes Room"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_WIND_HINT_ROOM,                          RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9985,                        GI_SKULL_TOKEN,      "MQ GS Wind Hint Room", "Shadow Temple MQ GS Wind Hint Room"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_AFTER_WIND,                              RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9992,                        GI_SKULL_TOKEN,      "MQ GS After Wind", "Shadow Temple MQ GS After Wind"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_AFTER_SHIP,                              RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        10000,                       GI_SKULL_TOKEN,      "MQ GS After Ship", "Shadow Temple MQ GS After Ship"),
    RC_OBJECT(RC_SHADOW_TEMPLE_MQ_GS_NEAR_BOSS,                               RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_SHADOW_TEMPLE,          ACTOR_EN_SI,        SCENE_HAKADAN,                        9988,                        GI_SKULL_TOKEN,      "MQ GS Near Boss", "Shadow Temple MQ GS Near Boss"),
    RC_OBJECT(RC_BONGO_BONGO,                                                 RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_DOOR_WARP1,   SCENE_HAKADAN_BS,                     0x00,                        GI_NONE,             "Bongo Bongo", "Bongo Bongo"),
    RC_OBJECT(RC_SHADOW_TEMPLE_BONGO_BONGO_HEART,                             RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_SHADOW_TEMPLE,          ACTOR_ITEM_B_HEART, SCENE_HAKADAN_BS,                     0x00,                        GI_HEART_CONTAINER,  "Bongo Bongo Heart Container", "Shadow Temple Bongo Bongo Heart Container"),


    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FRONT_LEFT_FAKE_WALL_CHEST,               RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      22600,                       GI_KEY_SMALL,        "Front Left Fake Wall Chest", "Bottom of the Well Front Left Fake Wall Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FRONT_CENTER_BOMBABLE_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      20578,                       GI_BOMBCHUS_10,      "Front Center Bombable Chest", "Bottom of the Well Front Center Bombable Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_RIGHT_BOTTOM_FAKE_WALL_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      22597,                       GI_KEY_SMALL,        "Right Bottom Fake Wall Chest", "Bottom of the Well Right Bottom Fake Wall Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_COMPASS_CHEST,                            RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      2049,                        GI_COMPASS,          "Compass Chest", "Bottom of the Well Compass Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_CENTER_SKULLTULA_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      20558,                       GI_NUTS_5,           "Center Skulltula Chest", "Bottom of the Well Center Skulltula Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_BACK_LEFT_BOMBABLE_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      23684,                       GI_NUTS_10,          "Back Left Bombable Chest", "Bottom of the Well Back Left Bombable Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_LENS_OF_TRUTH_CHEST,                      RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      4419,                        GI_LENS,             "Lens of Truth Chest", "Bottom of the Well Lens of Truth Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_INVISIBLE_CHEST,                          RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      27348,                       GI_RUPEE_GOLD,       "Invisible Chest", "Bottom of the Well Invisible Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_UNDERWATER_FRONT_CHEST,                   RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      23760,                       GI_BOMBS_10,         "Underwater Front Chest", "Bottom of the Well Underwater Front Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_UNDERWATER_LEFT_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      22793,                       GI_HEART,            "Underwater Left Chest", "Bottom of the Well Underwater Left Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MAP_CHEST,                                RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      2087,                        GI_MAP,              "Map Chest", "Bottom of the Well Map Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FIRE_KEESE_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      21802,                       GI_SHIELD_DEKU,      "Fire Keese Chest", "Bottom of the Well Fire Keese Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_LIKE_LIKE_CHEST,                          RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      21836,                       GI_SHIELD_HYLIAN,    "Like Like Chest", "Bottom of the Well Like Like Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_FREESTANDING_KEY,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_ITEM00,    SCENE_HAKADANCH,                      273,                         GI_KEY_SMALL,        "Freestanding Key", "Bottom of the Well Freestanding Key"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_MAP_CHEST,                             RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      2083,                        GI_MAP,              "MQ Map Chest", "Bottom of the Well MQ Map Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_LENS_OF_TRUTH_CHEST,                   RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      -20159,                      GI_LENS,             "MQ Lens of Truth Chest", "Bottom of the Well MQ Lens of Truth Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_COMPASS_CHEST,                         RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_BOX,       SCENE_HAKADANCH,                      6146,                        GI_COMPASS,          "MQ Compass Chest", "Bottom of the Well MQ Compass Chest"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_DEAD_HAND_FREESTANDING_KEY,            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_ITEM00,    SCENE_HAKADANCH,                      529,                         GI_KEY_SMALL,        "MQ Dead Hand Freestanding Key", "Bottom of the Well MQ Dead Hand Freestanding Key"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_EAST_INNER_ROOM_FREESTANDING_KEY,      RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_ITEM00,    SCENE_HAKADANCH,                      273,                         GI_KEY_SMALL,        "MQ East Inner Room Freestanding Key", "Bottom of the Well MQ East Inner Room Freestanding Key"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_GS_LIKE_LIKE_CAGE,                        RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_HAKADANCH,                      10241,                       GI_SKULL_TOKEN,      "GS Like Like Cage", "Bottom of the Well GS Like Like Cage"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_GS_EAST_INNER_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_HAKADANCH,                      10242,                       GI_SKULL_TOKEN,      "GS East Inner Room", "Bottom of the Well GS East Inner Room"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_GS_WEST_INNER_ROOM,                       RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_HAKADANCH,                      10244,                       GI_SKULL_TOKEN,      "GS West Inner Room", "Bottom of the Well GS West Inner Room"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_GS_BASEMENT,                           RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_HAKADANCH,                      10241,                       GI_SKULL_TOKEN,      "MQ GS Basement", "Bottom of the Well MQ GS Basement"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_GS_COFFIN_ROOM,                        RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_HAKADANCH,                      10244,                       GI_SKULL_TOKEN,      "MQ GS Coffin Room", "Bottom of the Well MQ GS Coffin Room"),
    RC_OBJECT(RC_BOTTOM_OF_THE_WELL_MQ_GS_WEST_INNER_ROOM,                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_BOTTOM_OF_THE_WELL,     ACTOR_EN_SI,        SCENE_HAKADANCH,                      10242,                       GI_SKULL_TOKEN,      "MQ GS West Inner Room", "Bottom of the Well MQ GS West Inner Room"),


    RC_OBJECT(RC_ICE_CAVERN_MAP_CHEST,                                        RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_DOUKUTO,                    2080,                        GI_MAP,              "Map Chest", "Ice Cavern Map Chest"),
    RC_OBJECT(RC_ICE_CAVERN_COMPASS_CHEST,                                    RCVORMQ_VANILLA, RCTYPE_MAP_COMPASS,  RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_DOUKUTO,                    2049,                        GI_COMPASS,          "Compass Chest", "Ice Cavern Compass Chest"),
    RC_OBJECT(RC_ICE_CAVERN_IRON_BOOTS_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_DOUKUTO,                    5570,                        GI_BOOTS_IRON,       "Iron Boots Chest", "Ice Cavern Iron Boots Chest"),
    RC_OBJECT(RC_ICE_CAVERN_FREESTANDING_POH,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_ICE_CAVERN,             ACTOR_EN_ITEM00,    SCENE_ICE_DOUKUTO,                    262,                         GI_HEART_PIECE,      "Freestanding PoH", "Ice Cavern Freestanding PoH"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_IRON_BOOTS_CHEST,                              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_DOUKUTO,                    5570,                        GI_BOOTS_IRON,       "MQ Iron Boots Chest", "Ice Cavern MQ Iron Boots Chest"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_COMPASS_CHEST,                                 RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_DOUKUTO,                    2048,                        GI_COMPASS,          "MQ Compass Chest", "Ice Cavern MQ Compass Chest"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_MAP_CHEST,                                     RCVORMQ_MQ,      RCTYPE_MAP_COMPASS,  RCAREA_ICE_CAVERN,             ACTOR_EN_BOX,       SCENE_ICE_DOUKUTO,                    -18399,                      GI_MAP,              "MQ Map Chest", "Ice Cavern MQ Map Chest"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_FREESTANDING_POH,                              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_ICE_CAVERN,             ACTOR_EN_ITEM00,    SCENE_ICE_DOUKUTO,                    262,                         GI_HEART_PIECE,      "MQ Freestanding PoH", "Ice Cavern MQ Freestanding PoH"),
    RC_OBJECT(RC_ICE_CAVERN_GS_PUSH_BLOCK_ROOM,                               RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_DOUKUTO,                    10497,                       GI_SKULL_TOKEN,      "GS Push Block Room", "Ice Cavern GS Push Block Room"),
    RC_OBJECT(RC_ICE_CAVERN_GS_SPINNING_SCYTHE_ROOM,                          RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_DOUKUTO,                    10498,                       GI_SKULL_TOKEN,      "GS Spinning Scythe Room", "Ice Cavern GS Spinning Scythe Room"),
    RC_OBJECT(RC_ICE_CAVERN_GS_HEART_PIECE_ROOM,                              RCVORMQ_VANILLA, RCTYPE_SKULL_TOKEN,  RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_DOUKUTO,                    10500,                       GI_SKULL_TOKEN,      "GS Heart Piece Room", "Ice Cavern GS Heart Piece Room"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_GS_SCARECROW,                                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_DOUKUTO,                    10497,                       GI_SKULL_TOKEN,      "MQ GS Scarecrow", "Ice Cavern MQ GS Scarecrow"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_GS_ICE_BLOCK,                                  RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_DOUKUTO,                    10500,                       GI_SKULL_TOKEN,      "MQ GS Ice Block", "Ice Cavern MQ GS Ice Block"),
    RC_OBJECT(RC_ICE_CAVERN_MQ_GS_RED_ICE,                                    RCVORMQ_MQ,      RCTYPE_SKULL_TOKEN,  RCAREA_ICE_CAVERN,             ACTOR_EN_SI,        SCENE_ICE_DOUKUTO,                    10498,                       GI_SKULL_TOKEN,      "MQ GS Red Ice", "Ice Cavern MQ GS Red Ice"),
    RC_OBJECT(RC_SHEIK_IN_ICE_CAVERN,                                         RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_ICE_CAVERN,             ACTOR_ID_MAX,       SCENE_ICE_DOUKUTO,                    0x00,                        GI_NONE,             "Sheik in Ice Cavern", "Sheik in Ice Cavern"),


    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_LOBBY_LEFT_CHEST,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30573,                      GI_MAGIC_LARGE,      "Lobby Left Chest", "Gerudo Training Grounds Lobby Left Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_LOBBY_RIGHT_CHEST,                    RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30393,                      GI_ARROWS_MEDIUM,    "Lobby Right Chest", "Gerudo Training Grounds Lobby Right Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_STALFOS_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30656,                      GI_KEY_SMALL,        "Stalfos Chest", "Gerudo Training Grounds Stalfos Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_BEAMOS_CHEST,                         RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30655,                      GI_KEY_SMALL,        "Beamos Chest", "Gerudo Training Grounds Beamos Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HIDDEN_CEILING_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22603,                       GI_KEY_SMALL,        "Hidden Ceiling Chest", "Gerudo Training Grounds Hidden Ceiling Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_FIRST_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            23206,                       GI_RUPEE_PURPLE,     "Maze Path First Chest", "Gerudo Training Grounds Maze Path First Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_SECOND_CHEST,               RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22986,                       GI_RUPEE_RED,        "Maze Path Second Chest", "Gerudo Training Grounds Maze Path Second Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_THIRD_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22889,                       GI_ARROWS_LARGE,     "Maze Path Third Chest", "Gerudo Training Grounds Maze Path Third Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_PATH_FINAL_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            2860,                        GI_ARROW_ICE,        "Maze Path Final Chest", "Gerudo Training Grounds Maze Path Final Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_RIGHT_CENTRAL_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            23877,                       GI_BOMBCHUS_5,       "Maze Right Central Chest", "Gerudo Training Grounds Maze Right Central Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MAZE_RIGHT_SIDE_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22888,                       GI_ARROWS_LARGE,     "Maze Right Side Chest", "Gerudo Training Grounds Maze Right Side Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_UNDERWATER_SILVER_RUPEE_CHEST,        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30643,                      GI_KEY_SMALL,        "Underwater Silver Rupee Chest", "Gerudo Training Grounds Underwater Silver Rupee Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HAMMER_ROOM_CLEAR_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            31058,                       GI_ARROWS_MEDIUM,    "Hammer Room Clear Chest", "Gerudo Training Grounds Hammer Room Clear Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HAMMER_ROOM_SWITCH_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22608,                       GI_KEY_SMALL,        "Hammer Room Switch Chest", "Gerudo Training Grounds Hammer Room Switch Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_EYE_STATUE_CHEST,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30653,                      GI_KEY_SMALL,        "Eye Statue Chest", "Gerudo Training Grounds Eye Statue Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_NEAR_SCARECROW_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22596,                       GI_KEY_SMALL,        "Near Scarecrow Chest", "Gerudo Training Grounds Near Scarecrow Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_BEFORE_HEAVY_BLOCK_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            31089,                       GI_ARROWS_LARGE,     "Before Heavy Block Chest", "Gerudo Training Grounds Before Heavy Block Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_FIRST_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            31439,                       GI_RUPEE_GOLD,       "Heavy Block First Chest", "Gerudo Training Grounds Heavy Block First Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_SECOND_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            30862,                       GI_MAGIC_LARGE,      "Heavy Block Second Chest", "Gerudo Training Grounds Heavy Block Second Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_THIRD_CHEST,              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            26708,                       GI_KEY_SMALL,        "Heavy Block Third Chest", "Gerudo Training Grounds Heavy Block Third Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_HEAVY_BLOCK_FOURTH_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            24450,                       GI_ICE_TRAP,         "Heavy Block Fourth Chest", "Gerudo Training Grounds Heavy Block Fourth Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_FREESTANDING_KEY,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_ITEM00,    SCENE_MEN,                            273,                         GI_KEY_SMALL,        "Freestanding Key", "Gerudo Training Grounds Freestanding Key"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_LOBBY_RIGHT_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            23879,                       GI_BOMBCHUS_5,       "MQ Lobby Right Chest", "Gerudo Training Grounds MQ Lobby Right Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_LOBBY_LEFT_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22867,                       GI_ARROWS_MEDIUM,    "MQ Lobby Left Chest", "Gerudo Training Grounds MQ Lobby Left Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_FIRST_IRON_KNUCKLE_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30304,                      GI_RUPEE_BLUE,       "MQ First Iron Knuckle Chest", "Gerudo Training Grounds MQ First Iron Knuckle Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_BEFORE_HEAVY_BLOCK_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            31057,                       GI_ARROWS_MEDIUM,    "MQ Before Heavy Block Chest", "Gerudo Training Grounds MQ Before Heavy Block Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_EYE_STATUE_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -32669,                      GI_BOMBCHUS_10,      "MQ Eye Statue Chest", "Gerudo Training Grounds MQ Eye Statue Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_FLAME_CIRCLE_CHEST,                RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30642,                      GI_KEY_SMALL,        "MQ Flame Circle Chest", "Gerudo Training Grounds MQ Flame Circle Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_SECOND_IRON_KNUCKLE_CHEST,         RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            31058,                       GI_ARROWS_MEDIUM,    "MQ Second Iron Knuckle Chest", "Gerudo Training Grounds MQ Second Iron Knuckle Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_DINOLFOS_CHEST,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30655,                      GI_KEY_SMALL,        "MQ Dinolfos Chest", "Gerudo Training Grounds MQ Dinolfos Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_ICE_ARROWS_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -17628,                      GI_ARROW_ICE,        "MQ Ice Arrows Chest", "Gerudo Training Grounds MQ Ice Arrows Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_RIGHT_CENTRAL_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22661,                       GI_MAGIC_LARGE,      "MQ Maze Right Central Chest", "Gerudo Training Grounds MQ Maze Right Central Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_PATH_FIRST_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22918,                       GI_RUPEE_GREEN,      "MQ Maze Path First Chest", "Gerudo Training Grounds MQ Maze Path First Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_RIGHT_SIDE_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            24136,                       GI_RUPEE_GREEN_LOSE, "MQ Maze Right Side Chest", "Gerudo Training Grounds MQ Maze Right Side Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_PATH_THIRD_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            24137,                       GI_RUPEE_GREEN_LOSE, "MQ Maze Path Third Chest", "Gerudo Training Grounds MQ Maze Path Third Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_MAZE_PATH_SECOND_CHEST,            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            22986,                       GI_RUPEE_RED,        "MQ Maze Path Second Chest", "Gerudo Training Grounds MQ Maze Path Second Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_HIDDEN_CEILING_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            23211,                       GI_RUPEE_PURPLE,     "MQ Hidden Ceiling Chest", "Gerudo Training Grounds MQ Hidden Ceiling Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_UNDERWATER_SILVER_RUPEE_CHEST,     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            -30643,                      GI_KEY_SMALL,        "MQ Underwater Silver Rupee Chest", "Gerudo Training Grounds MQ Underwater Silver Rupee Chest"),
    RC_OBJECT(RC_GERUDO_TRAINING_GROUND_MQ_HEAVY_BLOCK_CHEST,                 RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GERUDO_TRAINING_GROUND, ACTOR_EN_BOX,       SCENE_MEN,                            31394,                       GI_RUPEE_PURPLE,     "MQ Heavy Block Chest", "Gerudo Training Grounds MQ Heavy Block Chest"),


    RC_OBJECT(RC_GANONS_TOWER_BOSS_KEY_CHEST,                                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANON,                          10219,                       GI_KEY_BOSS,         "Boss Key Chest", "Ganon's Tower Boss Key Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_FOREST_TRIAL_CHEST,                            RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      30857,                       GI_MAGIC_LARGE,      "Forest Trial Chest", "Ganon's Castle Forest Trial Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_WATER_TRIAL_LEFT_CHEST,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      24455,                       GI_ICE_TRAP,         "Water Trial Left Chest", "Ganon's Castle Water Trial Left Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_WATER_TRIAL_RIGHT_CHEST,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      22790,                       GI_HEART,            "Water Trial Right Chest", "Ganon's Castle Water Trial Right Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_SHADOW_TRIAL_FRONT_CHEST,                      RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      22664,                       GI_MAGIC_LARGE,      "Shadow Trial Front Chest", "Ganon's Castle Shadow Trial Front Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_SHADOW_TRIAL_GOLDEN_GAUNTLETS_CHEST,           RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      14021,                       GI_GAUNTLETS_GOLD,   "Shadow Trial Golden Gauntlets Chest", "Ganon's Castle Shadow Trial Golden Gauntlets Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_SPIRIT_TRIAL_CRYSTAL_SWITCH_CHEST,             RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -29326,                      GI_BOMBCHUS_20,      "Spirit Trial Crystal Switch Chest", "Ganon's Castle Spirit Trial Crystal Switch Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_SPIRIT_TRIAL_INVISIBLE_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      26964,                       GI_ARROWS_MEDIUM,    "Spirit Trial Invisible Chest", "Ganon's Castle Spirit Trial Invisible Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_FIRST_LEFT_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      22668,                       GI_MAGIC_LARGE,      "Light Trial First Left Chest", "Ganon's Castle Light Trial First Left Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_SECOND_LEFT_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      24459,                       GI_ICE_TRAP,         "Light Trial Second Left Chest", "Ganon's Castle Light Trial Second Left Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_THIRD_LEFT_CHEST,                  RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      22797,                       GI_HEART,            "Light Trial Third Left Chest", "Ganon's Castle Light Trial Third Left Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_FIRST_RIGHT_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      24462,                       GI_ICE_TRAP,         "Light Trial First Right Chest", "Ganon's Castle Light Trial First Right Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_SECOND_RIGHT_CHEST,                RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      22890,                       GI_ARROWS_LARGE,     "Light Trial Second Right Chest", "Ganon's Castle Light Trial Second Right Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_THIRD_RIGHT_CHEST,                 RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      24463,                       GI_ICE_TRAP,         "Light Trial Third Right Chest", "Ganon's Castle Light Trial Third Right Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_INVISIBLE_ENEMIES_CHEST,           RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      30800,                       GI_KEY_SMALL,        "Light Trial Invisible Enemies Chest", "Ganon's Castle Light Trial Invisible Enemies Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_LIGHT_TRIAL_LULLABY_CHEST,                     RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30639,                      GI_KEY_SMALL,        "Light Trial Lullaby Chest", "Ganon's Castle Light Trial Lullaby Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_CENTER_LEFT,                        RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x05,                        GI_BOMBS_5,          "Deku Scrub Center-Left", "Ganon's Castle Deku Scrub Center-Left"),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_CENTER_RIGHT,                       RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x03,                        GI_SEEDS_30,         "Deku Scrub Center-Right", "Ganon's Castle Deku Scrub Center-Right"),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_RIGHT,                              RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x07,                        GI_POTION_RED,       "Deku Scrub Right", "Ganon's Castle Deku Scrub Right"),
    RC_OBJECT(RC_GANONS_CASTLE_DEKU_SCRUB_LEFT,                               RCVORMQ_VANILLA, RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x08,                        GI_POTION_GREEN,     "Deku Scrub Left", "Ganon's Castle Deku Scrub Left"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_WATER_TRIAL_CHEST,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      22977,                       GI_RUPEE_RED,        "MQ Water Trial Chest", "Ganon's Castle MQ Water Trial Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_FOREST_TRIAL_EYE_SWITCH_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30398,                      GI_ARROWS_MEDIUM,    "MQ Forest Trial Eye Switch Chest", "Ganon's Castle MQ Forest Trial Eye Switch Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_FOREST_TRIAL_FROZEN_EYE_SWITCH_CHEST,       RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -32733,                      GI_BOMBS_5,          "MQ Forest Trial Frozen Eye Switch Chest", "Ganon's Castle MQ Forest Trial Frozen Eye Switch Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_LIGHT_TRIAL_LULLABY_CHEST,                  RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30460,                      GI_HEART,            "MQ Light Trial Lullaby Chest", "Ganon's Castle MQ Light Trial Lullaby Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SHADOW_TRIAL_BOMB_FLOWER_CHEST,             RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30400,                      GI_ARROWS_MEDIUM,    "MQ Shadow Trial Bomb Flower Chest", "Ganon's Castle MQ Shadow Trial Bomb Flower Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SHADOW_TRIAL_EYE_SWITCH_CHEST,              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30651,                      GI_KEY_SMALL,        "MQ Shadow Trial Eye Switch Chest", "Ganon's Castle MQ Shadow Trial Eye Switch Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_GOLDEN_GAUNTLETS_CHEST,        RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -18746,                      GI_GAUNTLETS_GOLD,   "MQ Spirit Trial Golden Gauntlets Chest", "Ganon's Castle MQ Spirit Trial Golden Gauntlets Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_SUN_BACK_RIGHT_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30457,                      GI_HEART,            "MQ Spirit Trial Sun Back Right Chest", "Ganon's Castle MQ Spirit Trial Sun Back Right Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_SUN_BACK_LEFT_CHEST,           RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30648,                      GI_KEY_SMALL,        "MQ Spirit Trial Sun Back Left Chest", "Ganon's Castle MQ Spirit Trial Sun Back Left Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_SUN_FRONT_LEFT_CHEST,          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      -30455,                      GI_HEART,            "MQ Spirit Trial Sun Front Left Chest", "Ganon's Castle MQ Spirit Trial Sun Front Left Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_FIRST_CHEST,                   RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      20586,                       GI_BOMBCHUS_10,      "MQ Spirit Trial First Chest", "Ganon's Castle MQ Spirit Trial First Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_SPIRIT_TRIAL_INVISIBLE_CHEST,               RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_BOX,       SCENE_GANONTIKA,                      26964,                       GI_ARROWS_MEDIUM,    "MQ Spirit Trial Invisible Chest", "Ganon's Castle MQ Spirit Trial Invisible Chest"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_FOREST_TRIAL_FREESTANDING_KEY,              RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_ITEM00,    SCENE_GANONTIKA,                      273,                         GI_KEY_SMALL,        "MQ Forest Trial Freestanding Key", "Ganon's Castle MQ Forest Trial Freestanding Key"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_RIGHT,                           RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x00,                        GI_NUTS_5_2,         "MQ Deku Scrub Right", "Ganon's Castle MQ Deku Scrub Right"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_CENTER_LEFT,                     RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x05,                        GI_BOMBS_5,          "MQ Deku Scrub Center-Left", "Ganon's Castle MQ Deku Scrub Center-Left"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_CENTER,                          RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x03,                        GI_SEEDS_30,         "MQ Deku Scrub Center", "Ganon's Castle MQ Deku Scrub Center"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_CENTER_RIGHT,                    RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x07,                        GI_POTION_RED,       "MQ Deku Scrub Center-Right", "Ganon's Castle MQ Deku Scrub Center-Right"),
    RC_OBJECT(RC_GANONS_CASTLE_MQ_DEKU_SCRUB_LEFT,                            RCVORMQ_MQ,      RCTYPE_STANDARD,     RCAREA_GANONS_CASTLE,          ACTOR_EN_DNS,       SCENE_GANONTIKA,                      0x08,                        GI_POTION_GREEN,     "MQ Deku Scrub Left", "Ganon's Castle MQ Deku Scrub Left"),


    RC_OBJECT(RC_UNKNOWN_CHECK,                                               RCVORMQ_BOTH,    RCTYPE_STANDARD,     RCAREA_INVALID,                ACTOR_ID_MAX,       SCENE_ID_MAX,                         0x00,                        GI_NONE,             "Invalid Check", "Invalid Check"),
};

std::map<RandomizerCheckArea, std::string> rcAreaNames = {
    { RCAREA_KOKIRI_FOREST, "Kokiri Forest"},
    { RCAREA_LOST_WOODS, "Lost Woods"},
    { RCAREA_SACRED_FOREST_MEADOW, "Sacred Forest Meadow"},
    { RCAREA_HYRULE_FIELD, "Hyrule Field"},
    { RCAREA_LAKE_HYLIA, "Lake Hylia"},
    { RCAREA_GERUDO_VALLEY, "Gerudo Valley"},
    { RCAREA_GERUDO_FORTRESS, "Gerudo Fortress"},
    { RCAREA_WASTELAND, "Desert Wasteland"},   
    { RCAREA_DESERT_COLOSSUS, "Desert Colossus"},
    { RCAREA_MARKET, "Hyrule Market"},
    { RCAREA_HYRULE_CASTLE, "Hyrule Castle"},
    { RCAREA_KAKARIKO_VILLAGE, "Kakariko Village"},    
    { RCAREA_GRAVEYARD, "Graveyard"},
    { RCAREA_DEATH_MOUNTAIN_TRAIL, "Death Mountain Trail"},
    { RCAREA_GORON_CITY, "Goron City"},
    { RCAREA_DEATH_MOUNTAIN_CRATER, "Death Mountain Crater"},
    { RCAREA_ZORAS_RIVER, "Zora's River"},
    { RCAREA_ZORAS_DOMAIN, "Zora's Domain"},
    { RCAREA_ZORAS_FOUNTAIN, "Zora's Fountain"},
    { RCAREA_LON_LON_RANCH, "Lon Lon Ranch"},
    { RCAREA_DEKU_TREE, "Deku Tree"},
    { RCAREA_DODONGOS_CAVERN, "Dodongo's Cavern"},
    { RCAREA_JABU_JABUS_BELLY, "Jabu Jabu's Belly"},    
    { RCAREA_FOREST_TEMPLE, "Forest Temple"},    
    { RCAREA_FIRE_TEMPLE, "Fire Temple"},    
    { RCAREA_WATER_TEMPLE, "Water Temple"},
    { RCAREA_SPIRIT_TEMPLE, "Spirit Temple"},
    { RCAREA_SHADOW_TEMPLE, "Shadow Temple"},
    { RCAREA_BOTTOM_OF_THE_WELL, "Bottom of the Well"},
    { RCAREA_ICE_CAVERN, "Ice Cavern"},
    { RCAREA_GERUDO_TRAINING_GROUND, "Gerudo Training Grounds"},
    { RCAREA_GANONS_CASTLE, "Ganon's Castle"},
    { RCAREA_INVALID, "Invalid"},
 };

std::map<RandomizerCheckArea, std::map<RandomizerCheck, RandomizerCheckObject>> rcObjectsByArea = {};

std::map<RandomizerCheckArea, std::map<RandomizerCheck, RandomizerCheckObject>> RandomizerCheckObjects::GetAllRCObjectsByArea() {
    if (rcObjectsByArea.size() == 0) {
        for (auto& [randomizerCheck, rcObject] : rcObjects) {
            rcObjectsByArea[rcObject.rcArea][randomizerCheck] = rcObject;
        }
    }

    return rcObjectsByArea;
}

bool RandomizerCheckObjects::AreaIsDungeon(RandomizerCheckArea area) {
    return area == RCAREA_GANONS_CASTLE ||
           area == RCAREA_GERUDO_TRAINING_GROUND ||
           area == RCAREA_ICE_CAVERN ||
           area == RCAREA_BOTTOM_OF_THE_WELL ||
           area == RCAREA_SHADOW_TEMPLE ||
           area == RCAREA_SPIRIT_TEMPLE ||
           area == RCAREA_WATER_TEMPLE ||
           area == RCAREA_FIRE_TEMPLE ||
           area == RCAREA_FOREST_TEMPLE ||
           area == RCAREA_JABU_JABUS_BELLY ||
           area == RCAREA_DODONGOS_CAVERN ||
           area == RCAREA_DEKU_TREE;
}

bool RandomizerCheckObjects::AreaIsOverworld(RandomizerCheckArea area) {
    return !AreaIsDungeon(area);
}

std::string RandomizerCheckObjects::GetRCAreaName(RandomizerCheckArea area) {
    return rcAreaNames[area];
}

std::map<RandomizerCheck, RandomizerCheckObject> RandomizerCheckObjects::GetAllRCObjects() {
    return rcObjects;
}

void RandomizerCheckObjects::UpdateImGuiVisibility() {
    for (auto& [randomizerCheck, locationIt] : rcObjects) {
        locationIt.visibleInImgui = (
            (locationIt.vOrMQ != RCVORMQ_MQ) && // don't show MQ checks until we support MQ
            (locationIt.rcType != RCTYPE_SHOP) && // don't show shop items until we have shopsanity
            (locationIt.rcType != RCTYPE_GOSSIP_STONE) && // don't show gossip stones (maybe gossipsanity will be a thing eventually?)
            (locationIt.rcType != RCTYPE_LINKS_POCKET) &&
            (locationIt.rcType != RCTYPE_CHEST_GAME) && // don't show non final reward chest game checks until we support shuffling them
            ((locationIt.rcType != RCTYPE_SKULL_TOKEN) ||
            (CVar_GetS32("gRandomizeShuffleTokens", 0) == 3) || // all tokens
            ((CVar_GetS32("gRandomizeShuffleTokens", 0) == 2) && RandomizerCheckObjects::AreaIsOverworld(locationIt.rcArea)) || // overworld tokens
            ((CVar_GetS32("gRandomizeShuffleTokens", 0) == 1) && RandomizerCheckObjects::AreaIsDungeon(locationIt.rcArea)) // dungeon tokens
            ) &&
            ((locationIt.rcType != RCTYPE_COW) || CVar_GetS32("gRandomizeShuffleCows", 0)) &&
            ((locationIt.rcType != RCTYPE_ADULT_TRADE) || CVar_GetS32("gRandomizeShuffleAdultTrade", 0)) &&
            ((locationIt.rc != RC_KF_KOKIRI_SWORD_CHEST) || CVar_GetS32("gRandomizeShuffleKokiriSword", 0)) &&
            ((locationIt.rc != RC_HC_MALON_EGG) || CVar_GetS32("gRandomizeShuffleWeirdEgg", 0)) &&
            ((locationIt.rc != RC_GF_GERUDO_MEMBERSHIP_CARD) || CVar_GetS32("gRandomizeShuffleGerudoToken", 0)) &&
            ((locationIt.rcType != RCTYPE_FROG_SONG) || CVar_GetS32("gRandomizeShuffleFrogSongRupees", 0)) &&
            ((locationIt.rcType != RCTYPE_MAP_COMPASS) || CVar_GetS32("gRandomizeStartingMapsCompasses", 0) != 1) && // 1 is the value for "vanilla" maps/compasses
            ((locationIt.rcType != RCTYPE_SMALL_KEY) || CVar_GetS32("gRandomizeKeysanity", 0) != 1) && // 1 is the value for "vanilla" small keys
            ((locationIt.rcType != RCTYPE_GF_KEY) || CVar_GetS32("randoShuffleGerudoFortressKeys", 0) != 0) && // 0 is the value for "vanilla" gf keys
            ((locationIt.rcType != RCTYPE_BOSS_KEY) || CVar_GetS32("gRandomizeBossKeysanity", 0) != 1) && // 1 is the value for "vanilla" boss keys
            ((locationIt.rcType != RCTYPE_GANON_BOSS_KEY) || CVar_GetS32("gRandomizeShuffleGanonBossKey", 0) != 0) // 0 is the value for "vanilla" ganon's boss key
        );
    }
}
